/**
 * Copyright (C) LiveFoundry Inc. 2013
 *
 * All rights reserved. Any use, copying, modification, distribution and selling
 * of this software and it's documentation for any purposes without authors'
 * written permission is hereby prohibited.
 *
 */




if(window.ADL === undefined) {

  /*jshint unused:false*/
  /**
   * AddLive namespace. Wraps all methods, classes, functions and constants
   * provided by the AddLive SDK.
   *
   * @externs
   * @namespace
   * @summary AddLive namespace - wraps complete SDK functionality.
   */
  var ADL = {};
  window.ADL = ADL;

  /**
   * @private
   * @namespace
   */
  window.ADL.MediaEngine = {};

  // Handle the case where local storage is not not allowed by IE. This yields access denied errors.
  try {
    window.ADL.localStorage = window.localStorage;
  } catch(e){
    window.ADL.localStorage = {};
  }
}

(function(a){a._STATIC_CONFIG={LOG_BUFFER_SIZE:100,SANE_DEFAULTS_CONN_DESCR:{videoStream:{maxWidth:640,maxHeight:480,maxFps:15,useAdaptation:!0,manualControl:!1},publishVideo:!0,publishAudio:!0},CONNECTS:{MAX_RETRIES:4,RETRY_INTERVAL:5E3},AMD_MODULE_NAME:"addlive-sdk",LOGS_PUBLISHING_INTERVAL:15E3,SERVICE_LOGS_TYPE:1,MAX_LOG_UPLOAD_PACKAGE_SIZE:512E3,DEFAULT_NATIVE_WIDTH:960,MAX_SAFE_FEEDS_SIZE:921600,RESOLVERS_SEPARATOR:"|",STREAMER_RESOLVE_MAX_ATTEMPTS:5,RETRY_DELAY:1E3,XHR_TIMEOUT:15E3,UPDATE_DESCRIPTOR_FETCH_TIMEOUT:15E3,
DEFAULT_PLATFORM_INIT_OPTIONS:{pluginPollFrequency:1E3,pluginHeartBeatInterval:1E3,reloadOnCrash:!0,initDevices:!0,skipUpdate:!1,updateDescriptorRoot:"",installationDescriptorRoot:"",trackingEndpoint:"",bugReportingEnabled:!0,streamerEndpointResolver:a._STREAMER_ENDPOINT_RESOLVER,useWebRTC:!0,webrtcMgmntProxyURL:"",renderResizerEnabled:!0},RECONNECT_MIN_INTERVAL:10,RECONNECT_MAX_INTERVAL:15,WebRTC:{MAX_VIDEO_BITRATE:800,MAX_CAM_WIDTH:640,MAX_CAM_HEIGHT:480,MAX_CAM_FPS:24,SAMPLE_AUDIO_URL:"//d36pfzlm4aixmv.cloudfront.net/resources/test.wav",
CONNECT_TIME_MAX:15E3,STATS_PUBLISH_INTERVAL:5E3,USE_NACK:!1,USE_FEC:!0,audioOnly:!1}}})(window.ADL);/*

 Copyright (C) SayMama Ltd 2012

 All rights reserved. Any use, copying, modification, distribution and selling
 of this software and it's documentation for any purposes without authors'
 written permission is hereby prohibited.
*/
(function(){ADL._UPDATE_DESCRIPTOR_NAME="update";ADL._MIC_CONFIG_KEY="com.addlive.SELECTED_MIC";ADL._SPK_CONFIG_KEY="com.addlive.SELECTED_SPK";ADL._CAM_CONFIG_KEY="com.addlive.SELECTED_CAM";ADL.ConnectionType={NOT_CONNECTED:"MEDIA_TRANSPORT_TYPE_NOT_CONNECTED",UDP_RELAY:"MEDIA_TRANSPORT_TYPE_UDP_RELAY",UDP_P2P:"MEDIA_TRANSPORT_TYPE_UDP_P2P",TCP_RELAY:"MEDIA_TRANSPORT_TYPE_TCP_RELAY"};ADL.ConnectionQuality={FINE:"CONN_QUALITY_FINE",AVERAGE:"CONN_QUALITY_AVERAGE",BAD:"CONN_QUALITY_BAD",UNKNOWN:"CONN_QUALITY_UNKNOWN",
_fromInt:function(a){switch(a){case 0:return this.FINE;case 1:return this.AVERAGE;case 2:return this.BAD;default:return this.UNKNOWN}}};ADL.MediaType={AUDIO:"audio",VIDEO:"video",SCREEN:"screen"};ADL.MediaType._fromInt=function(a){a=parseInt(a,10);switch(a){case 0:return ADL.MediaType.AUDIO;case 1:return ADL.MediaType.VIDEO;case 2:return ADL.MediaType.SCREEN;default:return""}};ADL.VideoScalingFilter={FAST_BILINEAR:"fast_bilinear",BICUBIC:"bicubic"};ADL.renderSink=function(a){ADL.Log.d("Trying to render feed from sink: "+
a.sinkId+". Will use "+a.containerId+" box as a container. Additional options: custom doc: "+a.document+", fullSize: "+a.fullSize+", windowless: "+a.windowless+", scaling filter: "+a.filterType);void 0===a.fullSize&&(a.fullSize=!0);void 0===a.document&&(a.document=window.document);void 0===a.mirror&&(a.mirror=!1);void 0===a.filterType&&(a.filterType="fast_bilinear");void 0===a.windowless&&(a.windowless=!0);if(ADL._usesWebRTC)ADL.MediaEngine.RenderCtrl.renderSink(a);else{var d=document.getElementById(a.containerId);
if(!d)throw ADL.Log.w("Can't render as the container with given ID was not found in DOM"),new ADL.AddLiveException("Invalid container ID, cannot find DOM node with given id.",ADL.ErrorCodes.Logic.INVALID_ARGUMENT);if(!a.sinkId)throw ADL.Log.w("Can't render as the sink id property is empty"),new ADL.AddLiveException("Invalid sink ID",ADL.ErrorCodes.Logic.INVALID_ARGUMENT);if(!ADL._service)throw ADL.Log.w("Cannot render as the service is not fully initialised."),new ADL.AddLiveException("Cannot render as the service is not fully initialised.",
ADL.ErrorCodes.Logic.INVALID_STATE);ADL.Utils.removeChildNodes(d);d.innerHTML='<object type="application/x-addliveplugin-v3"><param  name="vcamid" value="'+a.sinkId+'"/><param  name="serviceid" value="'+ADL._service.nativeService.serviceid+'"/><param  name="mirror" value="'+(a.mirror?"true":"false")+'"/><param  name="filtertype" value="'+a.filterType+'"/><param  name="windowless" value="'+(a.windowless?"true":"false")+'"/></object>';if(d&&d.children&&d.children[0]){var g=d.children[0];g.nodeName||
(g.nodeName="object");try{g.addLiveRenderer=!0,g.parentNode||(g.parentNode=d)}catch(i){}a.fullSize&&(g.style.width="100%",g.style.height="100%");g.style.background="black"}ADL.Log.d("Renderer created")}};ADL.disposeRenderer=function(a){ADL.Log.d("Disposing renderer with id: "+a);ADL._usesWebRTC&&ADL.MediaEngine.RenderCtrl.disposeRenderer(a);a=document.getElementById(a);if(!a)throw ADL.Log.w("Can't render as the container with given ID was not found in DOM"),new ADL.AddLiveException("Invalid container ID, cannot find DOM node with given id.",
ADL.ErrorCodes.Logic.INVALID_ARGUMENT);ADL.Utils.removeChildNodes(a)};ADL.getVersion=function(a){ADL._service?ADL._service.getVersion(a):setTimeout(function(){var d=document.createElement("div");d.style.position="fixed";d.style.overflow="hidden";d.style.width=10;d.style.height=10;d.style.top=0;d.style.left=-100;d.id="addLivePluginContainer"+(new Date).getTime();document.body.appendChild(d);var g=new ADL.AddLivePlugin(d.id,{}),i=g.loadPlugin();try{i?a.result(g.pluginInstance.version):a.error(ADL.ErrorCodes.Logic.INVALID_STATE,
"AddLive Service not available")}catch(c){}d.parentNode.removeChild(d)},0)};ADL.usesWebRTC=function(){return!!ADL._usesWebRTC};ADL.isWebRTCSupported=function(){return ADL.MediaEngine.isAvailable()};ADL.isPluginInstalled=function(){var a="addLivePluginContainer"+new Date,d=ADL.Utils.embedInvisibleContainer(a),g=new ADL.AddLivePlugin(a,{}),a=g.pluginInstalled()?!0:g.loadPlugin();g.unload();d.parentNode.removeChild(d);return a};ADL.AddLiveException=function(a,d){this.name="AddLiveException";this.message=
a;this.code=d};ADL.AddLiveEvent=function(){};ADL.AddLiveEvent.prototype={preventDefault:function(){this._isDefaultPrevented=!0},isDefaultPrevented:function(){return this._isDefaultPrevented},_isDefaultPrevented:!1};ADL._extend=function(a,d){for(var g in d.prototype)a.prototype[g]=d.prototype[g];return a};ADL._getUpdateDescriptorSuffix=function(){var a=ADL._getPlatformSuffix();if(a)return"."+a;throw new ADL.AddLiveException("Cannot update/install - platform unsupported",ADL.ErrorCodes.Logic.PLATFORM_UNSUPPORTED);
};ADL._getPlatformSuffix=function(){var a=ADL.Utils.HostOS;switch(ADL.Utils.getHostOS()){case a.WINDOWS_64_BIT:throw new ADL.AddLiveException('Browsers in "64-bit" mode or IE in "No Add-ons" mode are not supported, please run the plain mode or use 32 bit browser',ADL.ErrorCodes.Logic.PLATFORM_UNSUPPORTED);case a.OS_X_10_5:throw new ADL.AddLiveException("OS X 10.5 is not supported, please update to at least 10.6",ADL.ErrorCodes.Logic.PLATFORM_UNSUPPORTED);case a.WINDOWS:return"win";case a.OS_X_10_6_to_7:return"mac_10.6";
case a.OS_X_10_8_AND_ABOVE:return"mac"}return!1};ADL._nop=function(){};ADL._validateInterface=function(a,d,g){g||(g=[]);var a=new a,i;for(i in a)"function"===typeof a[i]&&"function"!==typeof d[i]&&g.push(i);return!g.length};ADL._isOwnProperty=function(a,d){return Object.prototype.hasOwnProperty.call(a,d)};ADL._WRTC_CONSTS={NativeErrors:{PERMISSION_DENIED:"PERMISSION_DENIED",PermissionDismissedError:"PermissionDismissedError",DevicesNotFoundError:"DevicesNotFoundError",DeviceCaptureError:"DeviceCaptureError"}}})();(function(a){function d(){ADL.Log.d=function(b){e._appendMsg(ADL.LogLevel.DEBUG,b);e._d(b)}}function g(b,f){return function(c){try{b(f,c)}catch(a){ADL.Log.e("Error in user defined log handler.")}}}function i(b,f){var c=b[f]();10>c&&(c="0"+c);return c}function c(b){var f=new Date,c=i(f,"getHours")+":"+i(f,"getMinutes")+":"+i(f,"getSeconds");b&&(b=f.getMilliseconds(),10>b?b="00"+b:100>b&&(b="0"+b),c+=":"+b);return c}function h(b,f){try{if(a.console&&a.console[f])return e["_"+b]=function(b){a.console[f](c(!0)+
" = "+b)},!0}catch(d){}return!1}ADL.LogLevel={DEBUG:"DEBUG",INFO:"INFO",WARN:"WARN",ERROR:"ERROR"};var e={d:function(){},i:function(b){e._appendMsg(ADL.LogLevel.INFO,b);e._i(b)},w:function(b){e._appendMsg(ADL.LogLevel.WARN,b);e._w(b)},e:function(b){e._appendMsg(ADL.LogLevel.ERROR,b);e._e(b)},_d:function(){},_i:function(){},_w:function(){},_e:function(){},_tail:[],getTail:function(){for(var b="",f=0;f<this._tail.length;f++)void 0!==this._tail[f]&&(b+=this._tail[f]+"\n");return b=b.replace(/\[log\]/,
"[log ]")},_appendMsg:function(b,f){e._tail.push(c()+" ["+b+"] "+f);e._tail.length>ADL._STATIC_CONFIG.LOG_BUFFER_SIZE&&e._tail.shift()}};ADL.initStdLogging=function(b){b&&(d(),h("d","log"));h("i","log");h("w","warn");h("e","error");e.d("Logging initialized")};ADL.initLogging=function(b,f){f&&(d(),e._d=g(b,ADL.LogLevel.DEBUG));e._i=g(b,ADL.LogLevel.INFO);e._w=g(b,ADL.LogLevel.WARN);e._e=g(b,ADL.LogLevel.ERROR);e.i("Logging initialized")};ADL.Log=e})(window);(function(){var a,d,g,i,c,h;function e(){var b="addLivePluginContainer"+Math.random().toString(36).substring(2,5);ADL.Utils.embedInvisibleContainer(b);ADL._pluginContainerId=b}function b(){s.d("Embedding the AddLive plugin inside a container with id: "+ADL._pluginContainerId);ADL._pluginInstance=new ADL.AddLivePlugin(ADL._pluginContainerId,ADL._platformOptions);return ADL._pluginInstance.loadPlugin()}function f(f){var c=new ADL.PluginUpdateListener;c.updateProgress=function(b){this.initListener.onInitProgressChanged(new ADL.InitProgressChangedEvent(a+
(d-a)*b/100))};c.updateStatus=function(f,c,a){var k=this.initListener;switch(f){case "UPDATING":j(k,new ADL.InitStateChangedEvent(ADL.InitState.UPDATE_BEGIN));break;case "UPDATED":D();e();b();l(k);break;case "UP_TO_DATE":l(k);break;case "UPDATED_RESTART":j(k,new ADL.InitStateChangedEvent(ADL.InitState.BROWSER_RESTART_REQUIRED),g);break;case "NEEDS_MANUAL_UPDATE":case "ERROR":s.w("Failed to update the plug-in."),o(k,a,c)}};try{c.initListener=f,j(f,void 0,a),ADL._pluginInstance.update(c)}catch(k){f.onInitStateChanged(new ADL.InitStateChangedEvent(ADL.InitState.ERROR,
"",k.code,k.message))}}function o(b){var f=null,c=null,k=null,a=!1,d=function(){if(f&&a){if(null===c||void 0===c)s.w("Failed to fetch the installer. Assuming service is fine."),c="1.0.0.0";var d;a:{var e=f.nativeService.version;d=c.split(".");for(var e=e.split("."),p=0;3>p;p++){var o=parseInt(d[p],10),h=parseInt(e[p],10);if(o>h){d=1;break a}else if(h<o){d=-1;break a}}d=0}0<d?(b._updateFailed=!0,s.e("Version installed is too old. Requesting user to auto update"),k?(d=new ADL.InitStateChangedEvent(ADL.InitState.NEEDS_MANUAL_UPDATE,
k),j(b,d,g)):j(b,new ADL.InitStateChangedEvent(ADL.InitState.ERROR),g)):l(b,f)}};ADL.getInstallerURL(ADL.r(function(b){k=b.url;c="3.0.0.0";a=!0;d()},function(){a=!0;d()}));ADL._pluginInstance.createService(ADL.r(function(b){f=b;d()},function(){s.e("Failed to create service to get the version.");f={nativeService:{version:"0.0.0.0"}};d()}))}function m(b){ADL.getInstallerURL(ADL.createResponder(function(f){j(b,new ADL.InitStateChangedEvent(ADL.InitState.INSTALLATION_REQUIRED,f.url));ADL._pluginInstance.startPolling(q(b),
ADL._platformOptions.pluginPollFrequency,ADL.r(function(){b.onInitStateChanged(new ADL.InitStateChangedEvent(ADL.InitState.USER_CONSENT_REQUIRED))}))},function(f,c){j(b,new ADL.InitStateChangedEvent(ADL.InitState.ERROR,void 0,f,c),g)}))}function j(b,f,j){try{if(j)b.onInitProgressChanged(new ADL.InitProgressChangedEvent(j));if(f)b.onInitStateChanged(f)}catch(c){s.w("Got an error in the init state change handler"),c.stack&&s.w(c.stack)}}function l(b,f){j(b,void 0,i);var a=function(f){j(b,void 0,c);
if(void 0===f.nativeService||null===f.nativeService)j(b,new ADL.InitStateChangedEvent(ADL.InitState.ERROR,void 0,ADL.ErrorCodes.Logic.PLATFORM_INIT_FAILED,"Internal error occurred that caused the plug-in to return an invalid AddLiveService"),g);else if(void 0===f.nativeService.getLogFileTag)j(b,new ADL.InitStateChangedEvent(ADL.InitState.ERROR,void 0,ADL.ErrorCodes.Logic.PLATFORM_INIT_FAILED,"Internal error occurred that caused the plug-in to return an invalid AddLiveService"),g);else{ADL._service=
f;ADL.CrashHandler.init(ADL._platformOptions);k();if(ADL._platformOptions.initDevices)t(b);else{var a=new ADL.InitStateChangedEvent(ADL.InitState.INITIALIZED);b._updateFailed&&(a.updateFailed=!0);j(b,a,g)}r(f)}},d=function(f,c){var a=ADL.Utils.errorToCause(c,f);s.e("Failed to create service: "+a);j(b,new ADL.InitStateChangedEvent(ADL.InitState.ERROR,void 0,f,c),g)};f?a(f):ADL._pluginInstance.createService(ADL.createResponder(a,d))}function k(){if(ADL._platformOptions.applicationId){var b=ADL._platformOptions.streamerEndpointResolver;
ADL._service.setProperty(ADL.r(),"global.service.streamer.endpointResolver",b);ADL._service.setApplicationId(ADL.r(function(){s.d("Successfully configured the application id")},function(b,f){s.e("Error settings the application id.");s.e("Cause: "+f+" (errCode: "+b+")")}),ADL._platformOptions.applicationId)}}function t(b){j(b,new ADL.InitStateChangedEvent(ADL.InitState.DEVICES_INIT_BEGIN),c);var f=3;b._currentProgress=c;var a=new ADL.InitStateChangedEvent(ADL.InitState.INITIALIZED),k=function(c,k){f--;
a[c+"DevFunctional"]=k;0===f?(delete b._currentProgress,b._updateFailed&&(a.updateFailed=!0),j(b,a,g)):(b._currentProgress+=5,j(b,void 0,b._currentProgress))};p("VideoCapture",ADL._CAM_CONFIG_KEY,k);p("AudioCapture",ADL._MIC_CONFIG_KEY,k);p("AudioOutput",ADL._SPK_CONFIG_KEY,k)}function p(b,f,j){var c="get"+b+"DeviceNames",a="set"+b+"Device",k=b.substring(0,1).toLowerCase()+b.substring(1);ADL._service[c](ADL.createResponder(function(b){var c=ADL.localStorage[f];if(!(c&&void 0!==b[c]))for(var d in b)if(b.hasOwnProperty(d)&&
"AirPlay"!==b[d]){c=d;ADL.localStorage[f]=c;break}ADL._service[a](ADL.createResponder(function(){j(k,!0)},function(){j(k,!1)}),c)},function(f,c){s.w("Failed to initialize device of type: "+b+" due to: "+c+"("+f+")");j()}))}function q(b,c){return function(){c?f(b):(j(b,new ADL.InitStateChangedEvent(ADL.InitState.INSTALLATION_COMPLETE),h),l(b))}}function r(b){b.getHostCpuDetails(ADL.r(function(b){x.CPU=b.brand_string}));b.getVideoCaptureDeviceNames(ADL.r(function(b){x.videoCapture=b}));b.getAudioCaptureDeviceNames(ADL.r(function(b){x.audioCapture=
b}));b.getAudioOutputDeviceNames(ADL.r(function(b){x.audioOutput=b}))}function D(){ADL._pluginInstance.unload();var b=document.getElementById(ADL._pluginContainerId);b.parentNode.removeChild(b);for(var b=document.getElementsByTagName("object"),f=0;f<b.length;f++){var c=b[f];c.addLiveRenderer&&c.parentNode.removeChild(c)}}var s=ADL.Log,E=ADL.MediaEngine;a=5;d=70;i=h=71;c=80;g=100;var x={};ADL.initPlatform=function(c,j){s.i("==================================================================");s.i("Initializing the AddLive JS SDK v"+
ADL.VERSION+" "+ADL.RELEASE_LEVEL);s.i("==================================================================");try{var a=ADL._STATIC_CONFIG.DEFAULT_PLATFORM_INIT_OPTIONS;a.configUrl=ADL._CONFIG_URL;a.bugReportingEndpoint=ADL._BUG_REPORTING_ENDPOINT;a.logsReportingEndpoint=ADL._LOGS_REPORTING_ENDPOINT;a.streamerEndpointResolver=ADL._STREAMER_ENDPOINT_RESOLVER;a.trackingEndpoint=ADL._TRACKING_ENDPOINT;if(void 0!==j){if(void 0!==j.pluginPollFrequency){var k=j.pluginPollFrequency;j.pluginPollFrequency=
parseInt(k,10);if(isNaN(j.pluginPollFrequency)||0>j.pluginPollFrequency)throw new ADL.AddLiveException("Invalid initialization options object - invalid pluginPollFrequency property value: "+k,ADL.ErrorCodes.Logic.INVALID_ARGUMENT);}if(void 0!==j.applicationId){var d=j.applicationId;j.applicationId=parseInt(d,10);if(isNaN(j.applicationId))throw new ADL.AddLiveException("Invalid initialization options object - invalid application id property value: "+d+". Number expected",ADL.ErrorCodes.Logic.INVALID_ARGUMENT);
}}var p=ADL._STATIC_CONFIG.DEFAULT_PLATFORM_INIT_OPTIONS;p.infrastructureVersion=ADL.VERSION;ADL._platformOptions={};ADL.Utils.merge(ADL._platformOptions,p);ADL._platformOptions.updateDescriptorRoot=ADL._PLUGIN_UPDATE_ROOT;ADL._platformOptions.installationDescriptorRoot=ADL._PLUGIN_INSTALL_ROOT;j&&ADL.Utils.merge(ADL._platformOptions,j);e();var o=!!/Linux/.test(window.navigator.userAgent);E.isAvailable()&&(ADL._platformOptions.useWebRTC||o)?(E.init(c,ADL._platformOptions),ADL._service=new ADL.AddLiveService(E.AddLiveServiceWrtcImpl),
ADL._usesWebRTC=!0):(e(),b()?ADL._platformOptions.skipUpdate?(s.w("AddLive Plug-in update was skipped. Do this only if you know what you're doing."),l(c)):f(c):ADL._pluginInstance.pluginInstalled()?(c.onInitStateChanged(new ADL.InitStateChangedEvent(ADL.InitState.USER_CONSENT_REQUIRED)),ADL._pluginInstance.startPolling(q(c,!0),ADL._platformOptions.pluginPollFrequency)):m(c))}catch(g){c.onInitProgressChanged(new ADL.InitProgressChangedEvent(100)),c.onInitStateChanged(new ADL.InitStateChangedEvent(ADL.InitState.ERROR,
void 0,g.code,g.message))}};ADL.getService=function(){return ADL._service};ADL.disposePlatform=function(){void 0!==ADL._service&&(s.d("Disposing platform"),ADL._usesWebRTC?ADL.MediaEngine.dispose():(ADL.CrashHandler.dispose(),D(),delete ADL._pluginInstance),delete ADL._service)};ADL.PlatformInitListener=function(){};ADL.PlatformInitListener.prototype={onInitStateChanged:function(b){s.d("Got init state changed event: "+JSON.stringify(b))},onInitProgressChanged:function(b){s.d("Got init progress changed event: "+
JSON.stringify(b))}};ADL.InitStateChangedEvent=function(b,f,c,j){this.state=b;this.errCode=c;this.errMessage=j;this.installerURL=f;this.usesWebRTC=this.audioOutputDevFunctional=this.audioCaptureDevFunctional=this.videoCaptureDevFunctional=!1};ADL._extend(ADL.InitStateChangedEvent,ADL.AddLiveEvent);ADL.InitProgressChangedEvent=function(b){this.progress=b};ADL.InitState={ERROR:"ERROR",INITIALIZED:"INITIALIZED",BROWSER_RESTART_REQUIRED:"BROWSER_RESTART_REQUIRED",INSTALLATION_REQUIRED:"INSTALLATION_REQUIRED",
INSTALLATION_COMPLETE:"INSTALLATION_COMPLETE",UPDATE_BEGIN:"UPDATE_STARTED",DEVICES_INIT_BEGIN:"DEVICES_INIT_BEGIN",NEEDS_MANUAL_UPDATE:"NEEDS_MANUAL_UPDATE",USER_CONSENT_REQUIRED:"USER_CONSENT_REQUIRED"};ADL.getInstallerURL=function(b){var f,c="-1/AddLive.";f=ADL.Utils.HostOS;switch(ADL.Utils.getHostOS()){case f.WINDOWS_64_BIT:b.error(ADL.ErrorCodes.Logic.PLATFORM_UNSUPPORTED,'Internet Explorer in "64-bit" or "No Add-ons" modes is not supported, please run the plain mode');return;case f.OS_X_10_5:b.error(ADL.ErrorCodes.Logic.PLATFORM_UNSUPPORTED,
"OS X 10.5 is not supported, please update to 10.6");return;case f.WINDOWS:c+="exe";f=ADL._PLUGIN_INSTALL_ROOT.win;break;case f.OS_X_10_6_to_7:c+="dmg";f=ADL._PLUGIN_INSTALL_ROOT.mac_106;break;case f.OS_X_10_8_AND_ABOVE:c+="dmg";f=ADL._PLUGIN_INSTALL_ROOT.mac;break;default:b.error(ADL.ErrorCodes.Logic.PLATFORM_UNSUPPORTED,"Unsupported browser.");return}if(void 0!==ADL._platformOptions.applicationId&&void 0!==ADL._APP_2_INSTALLER&&ADL._APP_2_INSTALLER[ADL._platformOptions.applicationId]){var c=ADL._APP_2_INSTALLER[ADL._platformOptions.applicationId],
j=ADL._getPlatformSuffix(),j=j.replace(/mac.*/,"mac");f=f+c+"/"+ADL._CUSTOM_INSTALLERS[c][j]}else f+=c;b.result({url:f,descriptor:void 0})};ADL._devices=x})();(function(){function a(a,g){if(void 0===a[g]||"function"!==typeof a[g])throw new ADL.AddLiveException("Invalid update listener - "+g+" method is missing or not a function",ADL.ErrorCodes.Logic.INVALID_ARGUMENT);}ADL.PluginWrapper=function(a){this.mimeType=a.mimeType;this.classId=a.classId;this.testMethod=a.testMethod;this.objectId=this.generateObjectTagId();this.params={};this.attributes={};this.polling=!1;this.height=this.width=0};ADL.PluginWrapper.prototype.startPolling=function(a,g,i){this.pollingCompleteHandler=
a;this.installedHandler=i;this.polling||(this.polling=!0,this._pollInterval=g||1E3,this._startPolling())};ADL.PluginWrapper.prototype.stopPolling=function(){clearTimeout(this.pollingTimer)};ADL.PluginWrapper.prototype.unload=function(){ADL.Log.d("[PluginWrapper] Trying to unload plug-in");this.pluginContainerId||ADL.Log.e("[PluginWrapper] Cannot unload plug-in: pluginContainerId was not specified");ADL.Log.d("[PluginWrapper] Removing OBJECT tag");ADL.Utils.removeChildNodes(document.getElementById(this.pluginContainerId));
ADL.Log.d("[PluginWrapper] OBJECT tag removed from DOM")};ADL.PluginWrapper.prototype.loadPlugin=function(){ADL.Log.d("[PluginWrapper] Trying to embed plug-in");try{navigator.plugins.refresh()}catch(a){ADL.Log.d("Failed to refresh "+a)}ADL.Log.d("[PluginWrapper] Setting up OBJECT tag");return this._loadByMime(this.mimeType)};ADL.PluginWrapper.prototype.generateObjectTagId=function(){for(var a="plugin_",g=0;5>g;g++)a+="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789".charAt(Math.floor(62*
Math.random()));return a};ADL.PluginWrapper.prototype.pluginInstalled=function(){try{if(window.navigator.plugins.length){for(var a=0;a<window.navigator.plugins.length;a++)for(var g=window.navigator.plugins[a],i=0;i<g.length;i++)if(g[i].type===this.mimeType)return!0;return!1}}catch(c){ADL.Log.w("Failed to check whether the plug-in is installed or not: "+c)}return null};ADL.PluginWrapper.prototype._startPolling=function(){var a=this;this.pollingTimer=setTimeout(function(){a._pollForPlugin()},this._pollInterval)};
ADL.PluginWrapper.prototype._pollForPlugin=function(){ADL.Log.d("[PluginWrapper] Polling for plug-in...");this.loadPlugin()?(ADL.Log.d("[PluginWrapper] Plugin loaded, notifying listener"),this.pollingCompleteHandler()):(this.installedHandler&&(this.pluginInstalled()&&!this.installedReported)&&(this.installedHandler.result(),this.installedReported=!0),ADL.Log.d("[PluginWrapper] failed to load the plug-in, retrying"),this._startPolling())};ADL.PluginWrapper.prototype._loadByMime=function(a){if(!this.pluginContainerId)return ADL.Log.e("[PluginWrapper] Cannot embed plug-in: pluginContainerId was not specified"),
!1;ADL.Log.d("[PluginWrapper] Resetting innerHTML of container");var g=document.getElementById(this.pluginContainerId);g.innerHTML=this._getObjectTag(a);g&&(g.children&&g.children[0])&&(a=g.children[0],a.nodeName||(a.nodeName="object"));ADL.Log.d("[PluginWrapper] OBJECT tag added to DOM. Testing for method: "+this.testMethod);this.pluginInstance=document.getElementById(this.objectId);(a=null===this.testMethod||this.testMethod in this.pluginInstance)||ADL.Log.d("[PluginWrapper] Plugin "+this.mimeType+
" seems not to be installed");return a};ADL.PluginWrapper.prototype._getObjectTag=function(a){var g="",i;for(i in this.attributes)this.attributes.hasOwnProperty(i)&&(g+=i+'="'+this.attributes[i]+'" ');a='<object type="'+a+'" id="'+this.objectId+'" width="1" height="1"'+g+">";for(i in this.params)this.params.hasOwnProperty(i)&&(a+='<param name="'+i+'" value="'+this.params[i]+'"/>');return a+"  </object>"};ADL.AddLivePlugin=function(a,g){this.pluginContainerId=a;g&&(void 0===g.useProxy&&(g.useProxy=
!0),this.params.useproxy=g.useProxy,this.attributes.useproxy=g.useProxy)};ADL.AddLivePlugin.prototype=new ADL.PluginWrapper({mimeType:"application/x-addliveplugin-v3",classId:"clsid: 051e3002-6ebb-5b93-9382-f13f091b2ab2",testMethod:"createService"});ADL.AddLivePlugin.prototype.constructor=ADL.AddLivePlugin;ADL.AddLivePlugin.prototype.createService=function(a){ADL.Log.d("[AddLivePlugin] Creating new plug-in service instance");a._realResultHandler=a.result;a.result=function(a){void 0!==a.init&&(a=new ADL.ServiceWrapper(a));
a=new ADL.AddLiveService(a);ADL._service=a;this._realResultHandler(a)};a.setMethod("createService()");this.pluginInstance.createService(a)};ADL.AddLivePlugin.prototype.update=function(d,g){ADL.Log.d("[AddLivePlugin] Updating plug-in");if(!g)var i=ADL._getUpdateDescriptorSuffix(),g=ADL._PLUGIN_UPDATE_ROOT[i.replace(/\./g,"")]+ADL._UPDATE_DESCRIPTOR_NAME+i;a(d,"updateProgress");a(d,"updateStatus");void 0===this.pluginInstance.updateCS?this.pluginInstance.update(d,g):this.pluginInstance.updateCS(d,g)};
ADL.AddLivePlugin.prototype.getLogFileTag=function(){ADL.Log.d("[AddLivePlugin] Retrieving container log file tag");return void 0===this.pluginInstance.getLogFileTag?null:this.pluginInstance.getLogFileTag()};ADL.AddLivePlugin.prototype.getLogFileByTag=function(a,g){ADL.Log.d("[AddLivePlugin] Retrieving log file by tag "+a);return void 0===this.pluginInstance.getLogFileByTag?"":this.pluginInstance.getLogFileByTag(a,g)};ADL.AddLivePlugin.prototype.getLogFileByTagMemSafe=function(a,g,i){ADL.Log.d("[AddLivePlugin] Retrieving log file by tag "+
a);void 0!==this.pluginInstance.getLogFileByTagMemSafe&&this.pluginInstance.getLogFileByTagMemSafe(a,g,i)};ADL.PluginUpdateListener=function(){};ADL.PluginUpdateListener.prototype.updateProgress=function(a){ADL.Log.d("Got new update progress: "+a)};ADL.PluginUpdateListener.prototype.updateStatus=function(a,g,i){ADL.Log.d("Got update state changed event: "+a+" "+g+" "+i)}})();(function(){function a(b,f){for(var c=0;c<h.length;c++)if(!h[c](b,f))return!1;return!0}function d(b,f,a){var e="Unknown exception";try{e=JSON.stringify(f),f.stack&&(e+="\n"+f.stack)}catch(j){c.e("Failed to stringify exception")}try{b="Got a JavaScript error calling method "+b+": "+e,c.e(b),a.error(ADL.ErrorCodes.Logic.INTERNAL,b)}catch(g){c.e("Error in report js error method")}}function g(b,f,c){b=new i(b,f,c);e[c.scopeId]=e;b.connect()}function i(b,f,c){this.service=b;this.responder=f;this.connDescriptor=
c;this.attempts=0;this.attemptsMax=ADL._STATIC_CONFIG.CONNECTS.MAX_RETRIES;this.retryFunctor=ADL.Utils.bind(this.connect,this)}var c=ADL.Log;ADL.AddLiveService=function(b){this.nativeService=b;this.serviceid=b.serviceid;this.version=b.version;this._activeConnections={};this.connLostHandler={};this.internalEventsHandler=new ADL.AddLiveServiceListener;var f=this;this.internalEventsHandler.onUserEvent=function(b){b._defaultHandlings+=1;f._activeConnections[b.scopeId]._onUserEvent(b)};this._cams={};this._spkrs=
[];this._mics=[];this.addServiceListener(ADL.r(),this.internalEventsHandler)};ADL.AddLiveService.prototype={getVersion:function(b){try{c.d("Getting service version"),ADL.Responder.validate(b),b.setMethod("getVersion()"),this.nativeService.getVersion(b)}catch(f){d("getVersion()",f,b)}},setApplicationId:function(b,f){var a="setApplicationId("+f+")";try{c.d("Setting application id"),ADL.Responder.validate(b),b.setMethod(a),ADL.Utils.validate(b,"appId|defined,number",f),this.nativeService.setApplicationId(b,
f)}catch(e){d(a,e,b)}},fetchConfig:function(b,f){var a="fetchConfig("+f+")";try{c.d("Fetching configuration from URL: "+f),ADL.Responder.validate(b),b.setMethod(a),ADL.Utils.validate(b,"configUrl|defined,string,nonEmpty",f)&&this.nativeService.fetchConfig(b,f)}catch(e){d(a,e,b)}},addServiceListener:function(b,f){try{ADL.Responder.validate(b),c.d("Calling plugin method addServiceListener({...})"),b.setMethod("addServiceListener({...})"),this.nativeService.addServiceListener(b,f)}catch(a){d("addServiceListener({...})",
a,b)}},removeServiceListener:function(b,f){try{ADL.Responder.validate(b),c.d("Calling plugin method removeServiceListener({...})"),b.setMethod("removeServiceListener({...})"),this.nativeService.removeServiceListener(b,f)}catch(a){d("removeServiceListener({...})",a,b)}},getHostCpuDetails:function(b){try{c.d("Calling plugin method getHostCpuDetails"),ADL.Responder.validate(b),b.setMethod("getHostCpuDetails()"),b.setResultAdapter(function(b){return"string"===typeof b?JSON.parse(b):b}),this.nativeService.getHostCpuDetails(b)}catch(f){d("getHostCpuDetails()",
f,b)}},getVideoCaptureDeviceNames:function(b){try{c.d("Calling plugin method getVideoCaptureDeviceNames()");ADL.Responder.validate(b);b.setMethod("getVideoCaptureDeviceNames()");var f=this;b.setResultAdapter(function(b){b||(b={});return f._cams=b});this.nativeService.getVideoCaptureDeviceNames(b)}catch(a){d("getVideoCaptureDeviceNames()",a,b)}},setVideoCaptureDevice:function(b,f){var a="setVideoCaptureDevice("+f+"/* "+this._cams[f]+" */)";try{c.d("Calling plugin method "+a),ADL.Responder.validate(b),
b.setMethod(a),ADL.Utils.validate(b,"deviceId|defined,string,nonEmpty",f)&&(b.setResultAdapter(function(){ADL.localStorage[ADL._CAM_CONFIG_KEY]=f;ADL._videoDeviceFunctional=!0}),this.nativeService.setVideoCaptureDevice(b,f))}catch(e){d(a,e,b)}},getVideoCaptureDevice:function(b){try{c.d("Calling plugin method getVideoCaptureDevice()"),ADL.Responder.validate(b),b.setMethod("getVideoCaptureDevice()"),this.nativeService.getVideoCaptureDevice(b)}catch(f){d("getVideoCaptureDevice()",f,b)}},getAudioCaptureDeviceNames:function(b){ADL.Responder.validate(b);
try{c.d("Calling plugin method getAudioCaptureDeviceNames()");b.setMethod("getAudioCaptureDeviceNames()");var f=this;b.setResultAdapter(function(b){b||(b=[]);return f._mics=b});this.nativeService.getAudioCaptureDeviceNames(b)}catch(a){d("getAudioCaptureDeviceNames()",a,b)}},setAudioCaptureDevice:function(b,f){var a="setAudioCaptureDevice("+f+"/* "+this._mics[f]+" */)";try{c.d("Calling plugin method "+a),ADL.Responder.validate(b),b.setMethod(a),b.setResultAdapter(function(){ADL.localStorage[ADL._MIC_CONFIG_KEY]=
f}),ADL.Utils.validate(b,"deviceId|defined",f)&&(f+="",this._handleYamahaCaseMaybe(b,f)||this.nativeService.setAudioCaptureDevice(b,f))}catch(e){d(a,e,b)}},_handleYamahaCaseMaybe:function(b,f){var a=/Yamaha PJP-20UR/;if(!a.test(this._mics[f]))return!1;c.w("Got the special Yamaha PJP-20UR device case");for(var e,j=0;j<this._spkrs.length;j++)if(a.test(this._spkrs[j])){e=j;break}if(e){var g=this;this.setAudioOutputDevice(ADL.r(function(){g.nativeService.setAudioCaptureDevice(b,f)},function(){g.nativeService.setAudioCaptureDevice(b,
f)}),e);return!0}return!1},getAudioCaptureDevice:function(b){ADL.Responder.validate(b);try{c.d("Calling plugin method getAudioCaptureDevice()"),b.setMethod("getAudioCaptureDevice()"),this.nativeService.getAudioCaptureDevice(b)}catch(f){d("getAudioCaptureDevice()",f,b)}},getAudioOutputDeviceNames:function(b){ADL.Responder.validate(b);try{c.d("Calling plugin method getAudioOutputDeviceNames()");b.setMethod("getAudioOutputDeviceNames()");var f=this;b.setResultAdapter(function(b){b||(b=[]);return f._spkrs=
b});this.nativeService.getAudioOutputDeviceNames(b)}catch(a){d("getAudioOutputDeviceNames()",a,b)}},setAudioOutputDevice:function(b,f){var a="setAudioOutputDevice("+f+"/* "+this._spkrs[f]+" */)";try{c.d("Calling plugin method "+a),b.setMethod(a),b.setResultAdapter(function(){ADL.localStorage[ADL._SPK_CONFIG_KEY]=f}),f+="",this.nativeService.setAudioOutputDevice(b,f)}catch(e){d(a,e,b)}},getAudioOutputDevice:function(b){ADL.Responder.validate(b);try{c.d("Calling plugin method getAudioOutputDevice()"),
b.setMethod("getAudioOutputDevice()"),this.nativeService.getAudioOutputDevice(b)}catch(f){d("getAudioOutputDevice()",f,b)}},getScreenCaptureSources:function(b,f){var a="getScreenCaptureSources("+f+")";try{c.d("Calling plugin method "+a),b.setMethod(a),ADL.Responder.validate(b),ADL.Utils.validate(b,"thumbWidth|defined,number",f)&&(b._originalResultHandler=b.result,b.result=function(b){"string"===typeof b&&(b=JSON.parse(b));this._originalResultHandler(b)},this.nativeService.getScreenCaptureSources(b,
f))}catch(e){d(a,e,b)}},startLocalVideo:function(b){ADL.Responder.validate(b);try{c.d("Calling plugin method startLocalVideo()"),b.setMethod("startLocalVideo()"),ADL._videoDeviceFunctional?this.nativeService.startLocalVideo(b,640,480):b.error(ADL.ErrorCodes.Media.INVALID_VIDEO_DEV,"Cannot start local video as there is no working camera functional. Select working camera first")}catch(f){d("startLocalVideo()",f,b)}},stopLocalVideo:function(b){try{c.d("Calling plugin method stopLocalVideo()"),b||(b=
ADL.createResponder()),b.setMethod("stopLocalVideo()"),this.nativeService.stopLocalVideo(b)}catch(f){d("stopLocalVideo()",f,b)}},connect:function(b,f){var e="connect("+JSON.stringify(f)+")";try{c.d("Calling plugin method "+e);b.setMethod(e);f.highVideoStream&&!f.videoStream&&(f.videoStream={maxWidth:f.highVideoStream.maxWidth,maxHeight:f.highVideoStream.maxHeight,maxFps:f.highVideoStream.maxFps,useAdaptation:!0,manualControl:!1});var h={};ADL.Utils.merge(h,ADL._STATIC_CONFIG.SANE_DEFAULTS_CONN_DESCR);
ADL.Utils.merge(h,f);if(a(b,h)){var j=h.scopeId;h.url&&(j=h.url.split("/")[1]);h.scopeId=j;var l=this;b.setResultAdapter(function(){var b=new ADL.MediaConnection(j,h);return l._activeConnections[j]=b});c.i("Connecting to Streamer with URL endpoint: "+h.scopeId);g(this.nativeService,b,h)}}catch(k){d(e,k,b)}},disconnect:function(b,f){var a="disconnect("+f+")";try{c.d("Calling plugin method "+a);"string"===typeof b&&(f=b,b=ADL.createResponder());var e=this;b.setMethod(a);b.setResultAdapter(function(){try{c.d("Connection successfully terminated. Disposing MediaConnection on JS side");
var b=e._activeConnections[f];delete e._activeConnections[f];b._dispose()}catch(a){}});ADL.Utils.validate(b,"scopeId|defined,string,nonEmpty",f)&&this.nativeService.disconnect(b,f)}catch(j){d(a,j,b)}},networkTest:function(b,f){var a="networkTest("+JSON.stringify(f)+")";try{c.d("Calling plugin method "+a);b.setMethod(a);var e={};ADL.Utils.merge(e,ADL._STATIC_CONFIG.SANE_DEFAULTS_CONN_DESCR);ADL.Utils.merge(e,f);c.i("Testing network connection to Streamer with URL endpoint: "+e.url);b.setResultAdapter(function(b){return ADL.ConnectionQuality._fromInt(parseInt(b,
10))});this.nativeService.networkTest(b,e)}catch(j){d(a,j,b)}},publish:function(b,a,e,h){var j="publish("+a+", "+e+", "+JSON.stringify(h)+")";try{c.d("Calling plugin method "+j),b.setMethod(j),this.nativeService.publish(b,a,e,h)}catch(g){d(j,g,b)}},unpublish:function(b,a,e){var h="unpublish("+a+", "+e+")";try{c.d("Calling plugin method "+h),b.setMethod(h),this.nativeService.unpublish(b,a,e)}catch(j){d(h,j,b)}},reconfigureVideo:function(b,a,e){var h="reconfigureVideo("+a+", "+e+")";try{c.d("Calling plugin method "+
h),b.setMethod(h),this.nativeService.reconfigureVideo(b,a,e)}catch(j){d(h,j,b)}},sendMessage:function(b,a,e,h){var j="sendMessage("+a+", "+e+", "+h+")";try{if(c.d("Calling plugin method "+j),b.setMethod(j),ADL.Utils.validate(b,"scopeId|defined,string,nonEmpty",a),ADL.Utils.validate(b,"message|defined,string",e),h){var g=parseInt(h,10);isNaN(h)&&b.error(ADL.ErrorCodes.Logic.INVALID_ARGUMENT,"Invalid user id given: "+h);this.nativeService.sendMessage(b,a,e,g)}else this.nativeService.sendMessage(b,a,
e)}catch(k){d(j,k,b)}},setAllowedSenders:function(b,a,e,h){var j="setAllowedSenders("+a+", "+e+", "+JSON.stringify(h)+")";try{c.d("Calling plugin method "+j),b.setMethod(j),ADL.Utils.validate(b,"scopeId|defined,string,nonEmpty",a),ADL.Utils.validate(b,"senders|defined",h),this.nativeService.setAllowedSenders(b,a,e,h)}catch(g){d(j,g,b)}},getSpeakersVolume:function(b){try{c.d("Calling plugin method getSpeakersVolume()"),b.setMethod("getSpeakersVolume()"),this.nativeService.getSpeakersVolume(b)}catch(a){d("getSpeakersVolume()",
a,b)}},setSpeakersVolume:function(b,a){var e="setSpeakersVolume("+a+")";try{c.d("Calling plugin method setSpeakersVolume("+a+")"),b.setMethod(e),ADL.Utils.validate(b,"volume|defined,number",a),this.nativeService.setSpeakersVolume(b,a)}catch(h){d(e,h,b)}},getMicrophoneVolume:function(b){try{c.d("Calling plugin method getMicrophoneVolume()"),b.setMethod("getMicrophoneVolume()"),this.nativeService.getMicrophoneVolume(b)}catch(a){d("getMicrophoneVolume()",a,b)}},setMicrophoneVolume:function(b,a){var e=
"setMicrophoneVolume("+a+")";try{c.d("Calling plugin method "+e),b.setMethod(e),ADL.Utils.validate(b,"volume|defined,number",a),this.nativeService.setMicrophoneVolume(b,a)}catch(h){d(e,h,b)}},monitorMicActivity:function(b,a){var e="monitorMicActivity("+a+")";try{c.d("Calling plugin method "+e),b.setMethod(e),ADL.Utils.validate(b,"enabled|defined,bool",a),this.nativeService.monitorMicActivity(b,a)}catch(h){d(e,h,b)}},monitorSpeechActivity:function(b,a,e){var h="monitorSpeechActivity("+a+", "+e+")";
try{c.d("Calling plugin method "+h),b.setMethod(h),ADL.Utils.validate(b,"scopeId|defined,string",a),ADL.Utils.validate(b,"enabled|defined,bool",e),this.nativeService.monitorSpeechActivity(b,a,e)}catch(j){d(h,j,b)}},startMeasuringStatistics:function(b,a,e){var h="startMeasuringStatistics("+a+", "+e+")";try{c.d("Calling plugin method "+h),b.setMethod(h),ADL.Utils.validate(b,"scopeId|defined,string,nonEmpty",a),ADL.Utils.validate(b,"interval|defined,number",e),this.nativeService.startMeasuringStatistics(b,
a,e)}catch(j){d(h,j,b)}},stopMeasuringStatistics:function(b,a){var e="stopMeasuringStatistics("+a+")";try{c.d("Calling plugin method "+e),b.setMethod(e),ADL.Utils.validate(b,"scopeId|defined,string,nonEmpty",a),this.nativeService.stopMeasuringStatistics(b,a)}catch(h){d(e,h,b)}},startPlayingTestSound:function(b){try{c.d("Calling plugin method startPlayingTestSound()"),b.setMethod("startPlayingTestSound()"),this.nativeService.startPlayingTestSound?this.nativeService.startPlayingTestSound(b):this.nativeService.playTestSound(b)}catch(a){d("startPlayingTestSound()",
a,b)}},stopPlayingTestSound:function(b){try{c.d("Calling plugin method stopPlayingTestSound()"),b.setMethod("stopPlayingTestSound()"),b.result()}catch(a){d("stopPlayingTestSound()",a,b)}},getProperty:function(b,a){var e="getProperty("+a+")";try{c.d("Calling plugin method "+e),b.setMethod(e),ADL.Utils.validate(b,"name|defined,string,nonEmpty",a),this.nativeService.getProperty(b,a)}catch(h){d(e,h,b)}},setProperty:function(b,a,e){var h="setProperty("+a+", "+e+")";try{c.d("Calling plugin method "+h),
b.setMethod(h),ADL.Utils.validate(b,"name|defined,string,nonEmpty",a),ADL.Utils.validate(b,"value|defined",a),this.nativeService.setProperty(b,a,e)}catch(j){d(h,j,b)}},getLogFileTag:function(b){try{c.d("Calling plugin method getLogFileTag()"),b.setMethod("getLogFileTag()"),this.nativeService.getLogFileTag(b)}catch(a){}},echo:function(b,a){this.nativeService.echo(b,a)},echoNotification:function(b,a){this.nativeService.echoNotification(b,a)}};var h=[function(b,a){return!a.url&&!a.scopeId?(b.error(ADL.ErrorCodes.Logic.INVALID_ARGUMENT,
"Cannot connect as neither scopeId or url not given in the connection descriptor."),!1):!0}],e={};i.prototype={connect:function(){var b=this;this.attempts+=1;this.service.connect(ADL.r(function(a){delete e[b.connDescriptor.scopeId];b.responder.result(a)},function(a,h){switch(a){case ADL.ErrorCodes.Communication.NETWORK_ERROR:case ADL.ErrorCodes.Communication.INVALID_HOST:case ADL.ErrorCodes.Communication.INVALID_PORT:case ADL.ErrorCodes.Communication.MEDIA_LINK_FAILURE:b.attempts>=b.attemptsMax?(c.w("Failed to connect "+
b.attempts+" times to AddLive scope "+b.connDescriptor.scopeId+". Reporting error to the application"),b.responder.error(a,h)):(c.w("Failed to connect to AddLive scope "+b.connDescriptor.scopeId+". Retrying"),setTimeout(b.retryFunctor,ADL._STATIC_CONFIG.CONNECTS.RETRY_INTERVAL));break;default:delete e[b.connDescriptor.scopeId],b.responder.error(a,h)}}),this.connDescriptor)}}})();(function(){ADL.AddLiveServiceListener=function(){};ADL.AddLiveServiceListener.prototype={onVideoFrameSizeChanged:function(a){a._defaultHandlings+=1},onConnectionLost:function(a){a._defaultHandlings+=1},onUserEvent:function(a){a._defaultHandlings+=1},onMediaStreamEvent:function(a){a._defaultHandlings+=1},onMicActivity:function(a){a._defaultHandlings+=1},onSpeechActivity:function(a){a._defaultHandlings+=1},onMicGain:function(a){a._defaultHandlings+=1},onDeviceListChanged:function(a){a._defaultHandlings+=
1},onMediaStats:function(a){a._defaultHandlings+=1},onMessage:function(a){a._defaultHandlings+=1},onMediaConnTypeChanged:function(a){a._defaultHandlings+=1},onMediaIssue:function(a){a._defaultHandlings+=1},onMediaStreamFailure:function(a){a._defaultHandlings+=1},onSessionReconnected:function(a){a._defaultHandlings+=1}};ADL.VideoFrameSizeChangedEvent=function(a){this.type="VideoFrameSizeChangedEvent";this.sinkId=a.sinkId;this.width=a.width;this.height=a.height;this._defaultHandlings=0};ADL.ConnectionLostEvent=
function(a){this.type="ConnectionLostEvent";this.scopeId=a.scopeId;this.errCode=a.errCode;this.errMessage=a.errMessage;this.willReconnect=a.willReconnect;this._defaultHandlings=0};ADL.UserStateChangedEvent=function(a){this.type="UserStateChangedEvent";this.scopeId=a.scopeId;this.userId=a.userDetails.id||a.userDetails.userId;this.mediaType=a.mediaType;this.isConnected=a.userDetails.isConnected;this.audioPublished=a.userDetails.audioPublished;this.videoPublished=a.userDetails.videoPublished;this.screenPublished=
a.userDetails.screenPublished;this.videoSinkId=a.userDetails.videoSinkId;this.screenSinkId=a.userDetails.screenSinkId;this._defaultHandlings=0};ADL.MicActivityEvent=function(a){this.type="MicActivityEvent";this.activity=a.activity;this._defaultHandlings=0};ADL.MicGainEvent=function(a){this.type="MicGainEvent";this.gain=a.gain;this._defaultHandlings=0};ADL.DeviceListChangedEvent=function(a){this.type="DeviceListChangedEvent";this.audioInChanged=a.audioInChanged;this.audioOutChanged=a.audioOutChanged;
this.videoInChanged=a.videoInChanged;this._defaultHandlings=0};ADL.MediaStatsEvent=function(a){this.type="MediaStatsEvent";this.scopeId=a.scopeId;this.mediaType=a.mediaType;this.stats=a.stats;this.remoteUserId=a.remoteUserId;this._defaultHandlings=0};ADL.MessageEvent=function(a){this.type="MessageEvent";this.scopeId=a.scopeId;this.srcUserId=a.srcUserId;this.data="string"===typeof a.data?a.data:JSON.stringify(a.data);this._defaultHandlings=0};ADL.MediaConnTypeChangedEvent=function(a){this.type="MediaConnTypeChangedEvent";
this.scopeId=a.scopeId;this.mediaType=a.mediaType;this.connectionType=a.connectionType;this._defaultHandlings=0};ADL.MediaIssueEvent=function(a){this.type="MediaIssueEvent";this.scopeId=a.scopeId;this.mediaType=ADL.MediaType._fromInt(a.mediaType);this.isActive=a.isActive;this.issueCode=ADL.MediaIssueCodes._fromInt(a.issueCode);this.message=a.message;this.affectedUserId=a.userId;this._defaultHandlings=0};ADL.MediaStreamFailureEvent=function(a){this.type="MediaStreamFailureEvent";this.scopeId=a.scopeId;
this.mediaType=a.mediaType;this.errCode=a.errCode;this.errMessage=a.errMessage;this._defaultHandlings=0};ADL.SessionReconnectedEvent=function(a){this.type="SessionReconnectedEvent";this.scopeId=a.scopeId;this._defaultHandlings=0};ADL.SpeechActivityEvent=function(a){this.type="SpeechActivityEvent";this.scopeId=a.scopeId;this.speechActivity=a.speechActivity;this.activeSpeakers=a.activeSpeakers;this._defaultHandlings=0}})();(function(){function a(){this.listeners=[]}function d(){}function g(a,c){return function(b){try{b[c](a)}catch(f){ADL.Log.w("Error in user defined "+c+" event handler"),f.stack&&ADL.Log.w("Error details: \n"+f.stack)}}}a.prototype={validateHandled:function(a,c){a._defaultHandlings===this.listeners.length&&ADL.Log.w("Got unhandled event: "+c+" ("+JSON.stringify(a)+")")},videoFrameSizeChanged:function(a,c,b){a=new ADL.VideoFrameSizeChangedEvent(a,c,b);this.listeners.forEach(g(a,"onVideoFrameSizeChanged"))},
connectionLost:function(a,c,b,f){a=new ADL.ConnectionLostEvent(a,c,b);c=g(a,"onConnectionLost");a.willReconnect=f?!1:ADL._platformOptions.enableReconnects;this.listeners.forEach(c);this.validateHandled(a,"onConnectionLost")},onUserEvent:function(a,c){var b=new ADL.UserStateChangedEvent(a,c);this.listeners.forEach(g(b,"onUserEvent"));this.validateHandled(b,"onUserEvent")},onVideoEvent:function(a,c){var b=new ADL.UserStateChangedEvent(a,c,ADL.MediaType.VIDEO);this.listeners.forEach(g(b,"onMediaStreamEvent"));
this.validateHandled(b,"onMediaStreamEvent")},onAudioEvent:function(a,c){var b=new ADL.UserStateChangedEvent(a,c,ADL.MediaType.AUDIO);this.listeners.forEach(g(b,"onMediaStreamEvent"));this.validateHandled(b,"onMediaStreamEvent")},onScreenEvent:function(a,c){var b=new ADL.UserStateChangedEvent(a,c,ADL.MediaType.SCREEN);this.listeners.forEach(g(b,"onMediaStreamEvent"));this.validateHandled(b,"onMediaStreamEvent")},onMediaStreamEvent:function(a){this.listeners.forEach(g(a,"onMediaStreamEvent"));this.validateHandled(a,
"onMediaStreamEvent")},micActivity:function(a){a=new ADL.MicActivityEvent(a);this.listeners.forEach(g(a,"onMicActivity"))},micGain:function(a){a=new ADL.MicGainEvent(a);this.listeners.forEach(g(a,"onMicGain"))},deviceListChanged:function(a,c,b){a=new ADL.DeviceListChangedEvent(a,c,b);this.listeners.forEach(g(a,"onDeviceListChanged"));this.validateHandled(a,"onDeviceListChanged")},newVideoStats:function(a,c,b){-1===c&&(c=void 0);a=new ADL.MediaStatsEvent(a,ADL.MediaType.VIDEO,b,c);this.listeners.forEach(g(a,
"onMediaStats"))},newAudioStats:function(a,c,b){-1===c&&(c=void 0);a=new ADL.MediaStatsEvent(a,ADL.MediaType.AUDIO,b,c);this.listeners.forEach(g(a,"onMediaStats"))},newScreenStats:function(a,c,b){-1===c&&(c=void 0);a=new ADL.MediaStatsEvent(a,ADL.MediaType.SCREEN,b,c);this.listeners.forEach(g(a,"onMediaStats"))},onBroadcast:function(a,c,b){void 0===b&&(b=c=a,a=void 0);a=new ADL.MessageEvent(a,c,b);this.listeners.forEach(g(a,"onMessage"));this.validateHandled(a,"onMessage")},newMediaConnectionType:function(a,
c,b){"AUDIO"===c?c=ADL.MediaType.AUDIO:"VIDEO"===c&&(c=ADL.MediaType.VIDEO);a=new ADL.MediaConnTypeChangedEvent(a,c,b);this.listeners.forEach(g(a,"onMediaConnTypeChanged"))},onEchoNotification:function(a){this.listener.onEchoNotification(a)},onMediaQualityIssueChange:function(a,c,b,f,d){a=new ADL.MediaIssueEvent({scopeId:a,mediaType:c,isActive:b,issueCode:f,message:d,userId:void 0});a.issueCode!==ADL.MediaIssueCodes.NETWORK_PROBLEM&&(this.listeners.forEach(g(a,"onMediaIssue")),this.validateHandled(a,
"onMediaIssue"))},onMediaStreamFailure:function(a,c,b,f){c=new ADL.MediaStreamFailureEvent(a,c,b,f);c.mediaType===ADL.MediaType.SCREEN&&(ADL._service.unpublish(ADL.r(),a,ADL.MediaType.SCREEN),this.listeners.forEach(g(c,"onMediaStreamFailure")),this.validateHandled(c,"onMediaStreamFailure"))},onSessionReconnected:function(a){this.listeners.forEach(g(a,"onSessionReconnected"))}};for(var i="connectionStatus userStatus videoPublished audioPublished screenPublished serviceInvalidated serviceRevalidated spkActivity".split(" "),
c=0;c<i.length;c++)a.prototype[i[c]]=d;ADL.ADLEventsRouter=a})();(function(){function a(){o=setTimeout(function(){d()&&a()},1E3)}function d(){if(null===document.getElementById(ADL._pluginContainerId))return g.e("Plugin's object node was deleted from the DOM tree."),!1;if(!(!ADL._pluginInstance||!ADL._pluginInstance.pluginInstance||!("echo"in ADL._pluginInstance.pluginInstance)?0:"1"===ADL._pluginInstance.pluginInstance.echo("1"))){g.e("Plug-in crashed! Marking it in local storage");var b=g.getTail();ADL.localStorage[i]="true";ADL.localStorage[c]=b;if(h)window.location.reload();
else for(b=0;b<f.length;b++)try{f[b]()}catch(a){g.w("Error in crash listener")}return!1}return!0}var g=ADL.Log,i="adl.crashed",c="adl.jsLogs",h=null,e=null,b=null,f=[],o;ADL.CrashHandler={};ADL.CrashHandler.init=function(c){g.d("Initializing the CrashHandler");h=c.reloadOnCrash;b=ADL._pluginInstance.getLogFileTag();ADL.localStorage["adl.containerLogsTag"]=b;ADL.localStorage["adl.version"]=ADL._service.version;ADL._service.getLogFileTag(ADL.r(function(b){e=b;ADL.localStorage["adl.serviceLogsTag"]=
e}));a()};ADL.CrashHandler.dispose=function(){g.d("Disposing the CrashHandler");clearTimeout(o)};ADL.CrashHandler.registerCrashListener=function(b){f.push(b)}})();(function(){ADL.ErrorCodes={};ADL.ErrorCodes.Logic={INVALID_ROOM:1001,INVALID_SCOPE:1001,INVALID_ARGUMENT:1002,INVALID_JS_PARAMETER_KEY:1003,PLATFORM_INIT_FAILED:1004,PLUGIN_UPDATING:1005,INTERNAL:1006,LIB_IN_USE:1007,PLATFORM_UNSUPPORTED:1009,INVALID_STATE:1010,USER_CONSENT_NOT_GIVEN:1101};ADL.ErrorCodes.Communication={INVALID_HOST:2001,INVALID_PORT:2002,BAD_AUTH:2003,MEDIA_LINK_FAILURE:2005,REMOTE_END_DIED:2006,INTERNAL:2007,ALREADY_JOINED:2009,PLUGIN_VERSION_NOT_SUPPORTED:2011,NETWORK_ERROR:2012,
PROXY_AUTH_ERROR:2013,PROXY_CONNECTION_FAILED:2014,NEW_USER_CONNECTION:2015};ADL.ErrorCodes.Media={INVALID_VIDEO_DEV:4001,NO_AUDIO_IN_DEV:4002,INVALID_AUDIO_IN_DEV:4003,INVALID_AUDIO_OUT_DEV:4004,INVALID_AUDIO_DEV:4005};ADL.ErrorCodes.Common={DEFAULT_ERROR:-1};ADL.MediaIssueCodes={CONNECTION_FROZEN:"CONNECTION_FROZEN",CPU_LOAD_HIGH:"CPU_LOAD_HIGH",EXTERNAL_CPU_LOAD_HIGH:"EXTERNAL_CPU_LOAD_HIGH",NETWORK_PROBLEM:"NETWORK_PROBLEM"};ADL.MediaIssueCodes._fromInt=function(a){a=parseInt(a,10);switch(a){case 1:return ADL.MediaIssueCodes.CONNECTION_FROZEN;
case 2:return ADL.MediaIssueCodes.CPU_LOAD_HIGH;case 3:return ADL.MediaIssueCodes.EXTERNAL_CPU_LOAD_HIGH;case 4:return ADL.MediaIssueCodes.NETWORK_PROBLEM;default:return""}};var a={};a[ADL.ErrorCodes.Media.INVALID_VIDEO_DEV]=!0;a[ADL.ErrorCodes.Logic.INVALID_SCOPE]=!0;a[ADL.ErrorCodes.Logic.INVALID_ARGUMENT]=!0;a[ADL.ErrorCodes.Logic.USER_CONSENT_NOT_GIVEN]=!0;a[ADL.ErrorCodes.Communication.NEW_USER_CONNECTION]=!0;a[ADL.ErrorCodes.Communication.BAD_AUTH]=!0;ADL.ErrorCodes._CLIENT_ERRORS=a})();var JSON;JSON||(JSON={});
(function(){function a(b){return 10>b?"0"+b:b}function d(a){c.lastIndex=0;return c.test(a)?'"'+a.replace(c,function(a){var c=b[a];return"string"===typeof c?c:"\\u"+("0000"+a.charCodeAt(0).toString(16)).slice(-4)})+'"':'"'+a+'"'}function g(b,a){var c,l,k,t,p=h,q,r=a[b];r&&("object"===typeof r&&"function"===typeof r.toJSON)&&(r=r.toJSON(b));"function"===typeof f&&(r=f.call(a,b,r));switch(typeof r){case "string":return d(r);case "number":return isFinite(r)?""+r:"null";case "boolean":case "null":return""+r;
case "object":if(!r)return"null";h+=e;q=[];if("[object Array]"===Object.prototype.toString.apply(r)){t=r.length;for(c=0;c<t;c+=1)q[c]=g(c,r)||"null";k=0===q.length?"[]":h?"[\n"+h+q.join(",\n"+h)+"\n"+p+"]":"["+q.join(",")+"]";h=p;return k}if(f&&"object"===typeof f){t=f.length;for(c=0;c<t;c+=1)"string"===typeof f[c]&&(l=f[c],(k=g(l,r))&&q.push(d(l)+(h?": ":":")+k))}else for(l in r)Object.prototype.hasOwnProperty.call(r,l)&&(k=g(l,r))&&q.push(d(l)+(h?": ":":")+k);k=0===q.length?"{}":h?"{\n"+h+q.join(",\n"+
h)+"\n"+p+"}":"{"+q.join(",")+"}";h=p;return k}}"function"!==typeof Date.prototype.toJSON&&(Date.prototype.toJSON=function(){return isFinite(this.valueOf())?this.getUTCFullYear()+"-"+a(this.getUTCMonth()+1)+"-"+a(this.getUTCDate())+"T"+a(this.getUTCHours())+":"+a(this.getUTCMinutes())+":"+a(this.getUTCSeconds())+"Z":null},String.prototype.toJSON=Number.prototype.toJSON=Boolean.prototype.toJSON=function(){return this.valueOf()});var i=/[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
c=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,h,e,b={"\u0008":"\\b","\t":"\\t","\n":"\\n","\u000c":"\\f","\r":"\\r",'"':'\\"',"\\":"\\\\"},f;"function"!==typeof JSON.stringify&&(JSON.stringify=function(b,a,c){var d;e=h="";if(typeof c==="number")for(d=0;d<c;d=d+1)e=e+" ";else typeof c==="string"&&(e=c);if((f=a)&&typeof a!=="function"&&(typeof a!=="object"||typeof a.length!=="number"))throw Error("JSON.stringify");return g("",
{"":b})});"function"!==typeof JSON.parse&&(JSON.parse=function(b,a){function c(b,f){var e,g,d=b[f];if(d&&typeof d==="object")for(e in d)if(Object.prototype.hasOwnProperty.call(d,e)){g=c(d,e);g!==void 0?d[e]=g:delete d[e]}return a.call(b,f,d)}var f,b=""+b;i.lastIndex=0;i.test(b)&&(b=b.replace(i,function(b){return"\\u"+("0000"+b.charCodeAt(0).toString(16)).slice(-4)}));if(/^[\],:{}\s]*$/.test(b.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,"@").replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,
"]").replace(/(?:^|:|,)(?:\s*\[)+/g,""))){f=eval("("+b+")");return typeof a==="function"?c({"":f},""):f}throw new SyntaxError("JSON.parse");})})();(function(a){var d;ADL.MediaConnection=function(a,i){d=ADL.Log;d.d("Creating an instance of MediaConnection class");this.scopeId=a;this.connDescriptor=i;this.userId=i.authDetails.userId;this._remotePeersCount=0;this._logsPusher=ADL.Utils.bind(this._postLogsLooper,this);this._logsPublished=0;var c=this,h=function(a){c._logsTag=a;c._clearLogs();c._postLogsLooper()};this._connected=!0;ADL._platformOptions.disableLogsPublishing||ADL.getService().getLogFileTag(ADL.r(h))};ADL.MediaConnection.prototype=
{publish:function(a,d,c){ADL.getService().publish(a,this.scopeId,d,c)},unpublish:function(a,d){ADL.getService().unpublish(a,this.scopeId,d)},publishAudio:function(a){this.publish(a,ADL.MediaType.AUDIO)},unpublishAudio:function(a){this.unpublish(a,ADL.MediaType.AUDIO)},publishVideo:function(a){this.publish(a,ADL.MediaType.VIDEO)},unpublishVideo:function(a){this.unpublish(a,ADL.MediaType.VIDEO)},publishScreen:function(a,d,c){void 0===c&&(c=ADL._STATIC_CONFIG.DEFAULT_NATIVE_WIDTH);this.publish(a,ADL.MediaType.SCREEN,
{windowId:d,nativeWidth:c})},unpublishScreen:function(a){this.unpublish(a,ADL.MediaType.SCREEN)},disconnect:function(a){ADL.getService().disconnect(a,this.scopeId);this._connected=!1},sendMessage:function(a,d,c){ADL.getService().sendMessage(a,this.scopeId,d,c)},reconfigureVideo:function(a,d){ADL.getService().reconfigureVideo(a,this.scopeId,d)},_dispose:function(){d.d("Disposing media connection");a.clearTimeout(this._logsPublishingInterval);this._postLogs()},_postLogsLooper:function(){this._postLogs();
this._logsPublishingInterval=a.setTimeout(this._logsPusher,ADL._STATIC_CONFIG.LOGS_PUBLISHING_INTERVAL)},_postLogs:function(){d.d("Posting logs");this.logs={};ADL._pluginInstance.getLogFileByTagMemSafe(this._logsTag,this._logsPublished,this.logs);this._logsPublished+=parseInt(this.logs.rawLength,10);void 0===this.logs.content||!this.logs.content?d.w("Skipping posting logs, as the content is undefined or empty"):this.logs.content.length>ADL._STATIC_CONFIG.MAX_LOG_UPLOAD_PACKAGE_SIZE?d.w("Skipping posting logs the content is to large: "+
this.logs.content.length+" bytes"):d.d("Sending logs: "+this.logs.content.length+" bytes after base encoding")},_clearLogs:function(){this.logs={};ADL._pluginInstance.getLogFileByTagMemSafe(this._logsTag,this._logsPublished,this.logs);this._logsPublished=parseInt(this.logs.rawLength,10);this.logs={}},_onUserEvent:function(a){if(!ADL._usesWebRTC&&(this._remotePeersCount=a.isConnected?this._remotePeersCount+1:this._remotePeersCount-1,!this.connDescriptor.videoStream.manualControl)){var d=this;setTimeout(function(){d.reconfigureVideo(ADL.r(),
d._getNewVideoConfiguration())},100)}},_getNewVideoConfiguration:function(){var a=this.connDescriptor.videoStream,d=a.maxWidth*a.maxHeight,c=ADL._STATIC_CONFIG.MAX_SAFE_FEEDS_SIZE/(d*this._remotePeersCount);1>c?(c*=d,d=Math.sqrt(a.maxWidth*c/a.maxHeight),c=Math.floor(c/d),d=Math.floor(d)):(d=a.maxWidth,c=a.maxHeight);return{useAdaptation:a.useAdaptation,maxWidth:d,maxHeight:c,maxFps:a.maxFps}}}})(window);(function(){var a=ADL.Log;ADL.Responder=function(a,g,i){void 0===i&&(i={});this._errHandler=g||ADL.Utils.nop();this._resultHandler=a||ADL.Utils.nop();ADL.Utils.merge(this,i);this._resultAdapter=function(a){return a}};ADL.Responder.prototype={error:function(d,g){var i=ADL.Utils.errorToCause(g,d);a.e("Got error result of method call: "+i);try{this._errHandler.call(this,d,g)}catch(c){a.w("Error in user defined error handler")}},result:function(d){var g=d;"string"===typeof d&&100<d.length&&(g=d.substring(0,
100)+"...");a.d("Got successful result of method call "+this.method+": "+g);try{d=this._resultAdapter(d),this._resultHandler.call(this,d)}catch(i){a.w("Error in user defined success handler for method: "+this.methodName),i.stack&&a.w(i.stack)}},resultAsync:function(a){var g=this;window.setTimeout(function(){g.result(a)},0)},errorAsync:function(a,g){var i=this;window.setTimeout(function(){i.error(a,g)},0)},setMethod:function(a){this.method=a},resultHandler:function(d){a.d("Got unhandled result: "+
JSON.stringify(d))},errHandler:function(d,g){a.w("Got unhandled error: "+d+": "+g)},setResultAdapter:function(a){this._resultAdapter=a}};ADL.Responder.validate=function(a){if(void 0===a)throw a="Responder not defined",ADL.Log.e(a),new ADL.AddLiveException(a,ADL.ErrorCodes.Logic.INVALID_ARGUMENT);if(!ADL._validateInterface(ADL.Responder,a))throw a="Invalid responder",ADL.Log.e(a),new ADL.AddLiveException(a,ADL.ErrorCodes.Logic.INVALID_ARGUMENT);};ADL.createResponder=function(a,g,i){return new ADL.Responder(a,
g,i)};ADL.namedResponder=function(a){var g=ADL.r();g.setMethod(a);return g};ADL.r=function(a,g,i){return ADL.createResponder(a,g,i)};ADL.nR=function(a){return ADL.namedResponder(a)}})();(function(a){function d(b){this.nativeService=b;this.eventsDispatcher=new i;this.nativeService.init(this,this.eventsDispatcher);this.reqIdGen=0;this.requests={};this.version=b.version;this.serviceid=b.serviceid;e.forEach(g)}function g(b){d.prototype[b]=function(a){for(var c=[],e=1;e<arguments.length;e++)c.push(arguments[e]);this._invoke(b,a,c)}}function i(){this.listeners=[];this._EVENT_NAME_TO_CLASS={onConnectionLost:c.ConnectionLostEvent,onDeviceListChanged:c.DeviceListChangedEvent,onMediaConnTypeChanged:c.MediaConnTypeChangedEvent,
onMediaIssue:c.MediaIssueEvent,onMediaStats:c.MediaStatsEvent,onMediaStreamEvent:c.UserStateChangedEvent,onMediaStreamFailure:c.MediaStreamFailureEvent,onMessage:c.MessageEvent,onMicActivity:c.MicActivityEvent,onMicGain:c.MicGainEvent,onSessionReconnected:c.SessionReconnectedEvent,onUserEvent:c.UserStateChangedEvent,onVideoFrameSizeChanged:c.VideoFrameSizeChangedEvent,onSpeechActivity:c.SpeechActivityEvent}}var c=a.ADL,h=c.Log,e="getVersion setApplicationId getScreenCaptureSources getVideoCaptureDeviceNames getVideoCaptureDevice setVideoCaptureDevice getAudioCaptureDeviceNames getAudioCaptureDevice setAudioCaptureDevice getAudioOutputDeviceNames getAudioOutputDevice setAudioOutputDevice getSpeakersVolume setSpeakersVolume getMicrophoneVolume setMicrophoneVolume getHostCpuDetails playTestSound startLocalVideo stopLocalVideo connect disconnect publish unpublish startMeasuringStatistics stopMeasuringStatistics monitorMicActivity monitorSpeechActivity getLogFileTag reconfigureVideo setProperty getProperty setProxyServer setProxyCredentials fetchConfig setAllowedSenders sendMessage echo networkTest".split(" ");
d.prototype={handleResult:function(b){h.d(("[App <---- SDK] Result: "+b).substr(0,250));var b=JSON.parse(b),a=this.requests[b.id];b.status?a.result(b.result):a.error(b.errorCode,b.errorMessage)},handleEvent:function(b){h.d("Got a new event: "+b)},addServiceListener:function(b,a){this.eventsDispatcher.addListener(a);b.resultAsync()},removeServiceListener:function(b,a){this.eventsDispatcher.removeListener(a);b.resultAsync()},_invoke:function(b,a,c){void 0===c&&(c=[]);var e=b+"_"+this.reqIdGen;this.requests[e]=
a;this.reqIdGen+=1;b=JSON.stringify({id:e,methodName:b,params:c});h.d("[App ----\> SDK] Call: "+b);this.nativeService.processRequestJSON(b)}};i.prototype={addListener:function(b){this.listeners.push(b)},removeListener:function(b){this.listeners.splice(this.listeners.indexOf(b),1)},handleEvent:function(b){h.d("[App <---- SDK] Event: "+b);"string"===typeof b&&(b=JSON.parse(b));if(void 0===this._EVENT_NAME_TO_CLASS[b.event])h.w("Got an unsupported event: "+b);else{var a=new this._EVENT_NAME_TO_CLASS[b.event](b.params);
this.listeners.forEach(function(c){if(void 0===c[b.event])h.w("Listener does not support event: "+b.event);else c[b.event](a)})}}};c.ServiceWrapper=d;c.EventsDispatcher=i})(window);(function(){function a(){var a;window.XMLHttpRequest?(a=new XMLHttpRequest,"withCredentials"in a||(a=new window.XDomainRequest,a.onload=function(){this.readyState=4;this.status=200;this.onreadystatechange()},a.onerror=a.ontimeout=function(){this.status=400;this.readyState=4;this.onreadystatechange()},a.onprogress=ADL._nop,a.timeout=ADL._STATIC_CONFIG.XHR_TIMEOUT)):a=new window.ActiveXObject("Microsoft.XMLHTTP");return a}function d(){}var g=ADL.Log;ADL.Utils={};var i={number:function(a){return!isNaN(parseInt(a+
"",10))},string:function(a){return"string"===typeof a||a instanceof String},defined:function(a){return null!==a&&void 0!==a},bool:function(a){return"boolean"===typeof a},nonEmpty:function(a){return 0<a.length}};ADL.Utils.errorToCause=function(a,d){return a+" ("+d+")"};ADL.Utils.merge=function(a,d){for(var e in d)d.hasOwnProperty(e)&&null!==d[e]&&(a[e]=d[e]);return a};ADL.Utils.bind=function(a,d){return void 0!==Function.prototype.bind?a.bind(d):function(){a.call(d)}};ADL.Utils.doGet=function(c,d,
e){var b=a();b.onreadystatechange=function(){4===b.readyState&&(200===b.status?c.result(b.responseText):c.error(b.status,"Error performing AJAX request"))};if(e){var d=d+"?",f;for(f in e)Object.prototype.hasOwnProperty.call(e,f)&&(d+=encodeURIComponent(f)+"="+encodeURIComponent(e[f])+"&")}b.open("GET",d,!0);b.send("")};ADL.Utils.doPost=function(c,d,e){var b="",f;for(f in e)Object.prototype.hasOwnProperty.call(e,f)&&(b+=f+"="+encodeURIComponent(e[f])+"&");var b=b.substring(0,b.length-1),i=a();i.onreadystatechange=
function(){4===i.readyState&&(200===i.status?c.resultAsync(i.responseText):c.errorAsync(i.status,"Error performing AJAX request"))};try{i.open("POST",d,!0)}catch(m){c.errorAsync(ADL.ErrorCodes.Communication.NETWORK_ERROR,"Failed to perform POST operation. URL: "+d+"Browser error: "+m);return}try{i.setRequestHeader("Content-type","application/x-www-form-urlencoded")}catch(j){g.d("Failed to set the content type")}i.send(b)};ADL.Utils.getScript=function(a,d){var e=document.getElementsByTagName("head")[0]||
document.documentElement,b=document.createElement("script");b.src=a;var f=!1;b.onload=b.onreadystatechange=function(){if(!f&&(!this.readyState||"loaded"===this.readyState||"complete"===this.readyState))f=!0,d.result(),b.onload=b.onreadystatechange=null,e&&b.parentNode&&e.removeChild(b)};e.insertBefore(b,e.firstChild)};ADL.Utils.nop=function(){return d};ADL.Utils.validate=function(a,d,e){g.d("Validating "+e+" against description: "+d);for(var b=d.split("|"),d=b[0],b=b[1].split(","),f=0;f<b.length;f++)if(void 0===
i[b[f]])g.e("Undefined validator: "+b[f]);else if(!i[b[f]](e))return e="Parameter "+d+" does not meet criteria: "+b[f]+". Input validation failed",g.w(e),a.error(ADL.ErrorCodes.Logic.INVALID_ARGUMENT,e),!1;return!0};ADL.Utils.randomString=function(a,d){for(var d=d||"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",e="",b=0;b<a;b++)var f=Math.floor(Math.random()*d.length),e=e+d.substring(f,f+1);return e};ADL.Utils.forEach=function(a,d){for(var e in a)Object.prototype.hasOwnProperty.call(a,
e)&&d(e,a[e])};ADL.Utils.embedInvisibleContainer=function(a){var d=document.createElement("div");d.style.position="fixed";d.style.overflow="hidden";d.style.width="10px";d.style.height="10px";d.style.top=0;d.style.left="-100px";d.id=a;document.body.appendChild(d);return d};ADL.Utils.removeChildNodes=function(a){for(;a.firstChild;)a.removeChild(a.firstChild)};void 0===ADL.localStorage&&(ADL.localStorage={});ADL.Storage=ADL.localStorage;ADL.Utils.HostOS={WINDOWS:"Windows",WINDOWS_64_BIT:"Windows64Bit",
OS_X_10_5:"OS_X_10_5",OS_X_10_6_to_7:"OS_X_10_6_to_7",OS_X_10_8_AND_ABOVE:"OS_X_10_8_AND_ABOVE"};ADL.Utils.getHostOS=function(){var a=window.navigator.userAgent,d=ADL.Utils.HostOS;if(/Win64; x64/.test(a))return d.WINDOWS_64_BIT;if(/Windows/.test(a))return d.WINDOWS;if(/Intel Mac OS X 10[._]5/.test(a))return d.OS_X_10_5;if(/Intel Mac OS X 10[._](6|7)/.test(a))return d.OS_X_10_6_to_7;if(/Intel Mac OS X 10[._](8|9|(10)|(11))/.test(a))return d.OS_X_10_8_AND_ABOVE};Array.prototype.forEach||(Array.prototype.forEach=
function(a,d){for(var e=0,b=this.length;e<b;++e)a.call(d,this[e],e,this)})})();(function(a){"function"===typeof a.define&&a.define.amd&&a.define(ADL._STATIC_CONFIG.AMD_MODULE_NAME,[],function(){return a.ADL})})(window);(function(){function a(b,a){b.errorAsync(d.ErrorCodes.Logic.PLATFORM_UNSUPPORTED,"The "+a+" method is not supported on WebRTC version of the SDK.")}var d=window.ADL,g=d.MediaEngine,i,c,h,e={init:function(){i=g.ConnCtrl;c=g.DevicesCtrl;h=new d.EventsDispatcher;e._eventsDispatcher=h},getVersion:function(b){b.resultAsync(g.version)},setApplicationId:function(b){b.errorAsync(d.ErrorCodes.Logic.PLATFORM_UNSUPPORTED,"setApplicationId is not supported on WebRTC version of the SDK. Use the applicationId param of the options object passed to ADL.initPlatform")},
fetchConfig:function(b){b.errorAsync(d.ErrorCodes.Logic.PLATFORM_UNSUPPORTED,"fetchConfig is not supported on WebRTC version of the SDK. Use the options object passed to ADL.initPlatform")},addServiceListener:function(b,a){h.addListener(a);b.resultAsync()},removeServiceListener:function(b,a){h.removeListener(a);b.resultAsync()},getHostCpuDetails:function(b){a(b,"getHostCpuDetails")},getVideoCaptureDeviceNames:function(b){c.getCameras(b)},getVideoCaptureDevice:function(b){c.getCamera(b)},setVideoCaptureDevice:function(b,
a){c.setCamera(b,a)},getAudioCaptureDeviceNames:function(b){c.getMicrophones(b)},getAudioCaptureDevice:function(b){c.getMicrophone(b)},setAudioCaptureDevice:function(b,a){c.setMicrophone(b,a)},getAudioOutputDeviceNames:function(b){c.getSpeakers(b)},getAudioOutputDevice:function(b){b.resultAsync(0)},setAudioOutputDevice:function(b){b.result()},getScreenCaptureSources:function(b){a(b,"getScreenCaptureSources")},startLocalVideo:function(b){c.startLocalVideo(b,h)},stopLocalVideo:function(b){c.stopLocalVideo(b)},
connect:function(b,a){i.connect(b,a,h)},disconnect:function(b,a){i.disconnect(b,a)},networkTest:function(b){a(b,"networkTest")},publish:function(b,c,e){e===d.MediaType.SCREEN?a(b,"publish(SCREEN)"):i.publish(b,c,e)},unpublish:function(b,c,e){e===d.MediaType.SCREEN?a(b,"unpublish(SCREEN)"):i.unpublish(b,c,e)},reconfigureVideo:function(b,a,c){i.reconfigureVideo(b,a,c)},sendMessage:function(b,a,c,e){i.sendMessage(b,a,c,e)},setAllowedSenders:function(b){a(b,"setAllowedSenders")},getSpeakersVolume:function(a){c.getVolume(a)},
setSpeakersVolume:function(a,e){c.setVolume(a,e)},getMicrophoneVolume:function(b){a(b,"getMicrophoneVolume")},setMicrophoneVolume:function(b){a(b,"setMicrophoneVolume")},monitorMicActivity:function(a,e){e?c.monitorMicActivity(a,h):c.stopMonitoringMicActivity(a)},monitorSpeechActivity:function(b){a(b,"monitorSpeechActivity")},startMeasuringStatistics:function(a,c,e){i.startMeasuringStatistics(a,c,e,h)},stopMeasuringStatistics:function(a,c){i.stopMeasuringStatistics(a,c)},startPlayingTestSound:function(a){c.playTestSound(a)},
stopPlayingTestSound:function(b){a(b,"stopPlayingTestSound")},getProperty:function(a){a.errorAsync(d.ErrorCodes.Logic.INVALID_ARGUMENT,"Unknown property key")},setProperty:function(a){a.errorAsync(d.ErrorCodes.Logic.INVALID_ARGUMENT,"Unknown property key")}};g.AddLiveServiceWrtcImpl=e})(window);(function(a){function d(a,b){return function(){var c=g(a);c?c.publishStats(b):window.clearInterval(m[a])}}function g(a,c){return void 0===b[a]?(c&&c.error(i.ErrorCodes.Logic.INVALID_SCOPE,"There is no active connection to a scope with id: "+a),!1):b[a]}var i=a.ADL,c=i.MediaEngine,h,e,b={},f,o,m={};c.ConnCtrl={init:function(a,b){e=i.Log;h=c.ScopeConnection;e.d("Initializing the Connectivity controller");f=b.webrtcMgmntProxyURL;o=b.applicationId},dispose:function(){e.d("Disposing connections controller");
for(var a in b)if(b.hasOwnProperty(a)){var c=b[a],f=i.r(void 0,void 0);f.setMethod("disconnect("+a+")");c.disconnect(f)}},connect:function(a,c,e){c.scopeId||(c.scopeId=c.url.split("/")[1],c.authDetails.scopeId=c.url.split("/")[1]);if(c.scopeId in b)a.error(i.ErrorCodes.Logic.INVALID_STATE,"Already connected to scope with id: "+c.scopeId);else{var d=c.scopeId,p=new h(c,f,e,o);p.connect(i.r(function(){b[d]=p;a.result()},function(b,c){a.error(b,c)}))}},disconnect:function(a,c){var e=g(c,a);e&&(e.disconnect(a),
delete b[c])},publish:function(a,b,c){(b=g(b,a))&&b.publish(a,c)},unpublish:function(a,b,c){(b=g(b,a))&&b.unpublish(a,c)},sendMessage:function(a,b,c,e){(b=g(b,a))&&b.sendMessage(a,c,e)},reconfigureVideo:function(a,b,c){if(b=g(b,a))b.reconfigureVideo(c),a.resultAsync()},startMeasuringStatistics:function(a,b,c,e){void 0!==m[b]?a.errorAsync(i.ErrorCodes.Logic.INVALID_STATE,"Measuring already started"):g(b,a)&&(m[b]=window.setInterval(d(b,e),1E3*c))},stopMeasuringStatistics:function(a,b){window.clearInterval(m[b]);
delete m[b];a.resultAsync()},_connLost:function(a,c){e.w("Got connection lost");m[a]&&(window.clearInterval(m[a]),delete m[a]);c&&delete b[a]},_activeConns:b}})(window);(function(a){var d,g,i,c,h,e;function b(a,b){var c="screenPreview"+(new Date).getTime(),e=n.Utils.embedInvisibleContainer(c),f=document.createElement("video");f.id="screenPreview_content"+(new Date).getTime();e.appendChild(f);f.src=window.URL.createObjectURL(b);f.style.width="320px";f.style.height="240px";f.play();var d=document.createElement("canvas");e.appendChild(d);d.id="screenGrab"+(new Date).getTime();setTimeout(function(){var c=f.videoWidth,j=f.videoHeight;f.style.width=c;f.style.height=j;
d.style.width=c;d.style.height=j;d.getContext("2d").drawImage(f,0,0,c,j);c=[{id:"desktop",image:{base64:d.toDataURL("image/png").substr(22),width:c,height:j},title:"Desktop"}];e.parentNode.removeChild(e);b.stop();a.resultAsync(c)},500)}function f(){u.d("Is video capture dev avail? ADL._STATIC_CONFIG.WebRTC.audioOnly "+n._STATIC_CONFIG.WebRTC.audioOnly);return 0<v.length&&!n._STATIC_CONFIG.WebRTC.audioOnly}function o(){var a=new Uint8Array(d.frequencyBinCount);d.getByteFrequencyData(a);for(var b=0,
c=0;c<a.length;c++)b=Math.max(a[c],b);g.handleEvent({event:"onMicActivity",params:{activity:b}})}function m(a){var b;switch(a.name){case n._WRTC_CONSTS.NativeErrors.PERMISSION_DENIED:case n._WRTC_CONSTS.NativeErrors.PermissionDismissedError:b=n.ErrorCodes.Logic.USER_CONSENT_NOT_GIVEN;a="User did not allow access to media device.";break;case n._WRTC_CONSTS.NativeErrors.DevicesNotFoundError:b=n.ErrorCodes.Media.INVALID_VIDEO_DEV;a="There are no video capture devices available in your system.";break;
case n._WRTC_CONSTS.NativeErrors.DeviceCaptureError:b=n.ErrorCodes.Media.INVALID_VIDEO_DEV;a="There was an error capturing video frames.";break;default:b=n.ErrorCodes.Common.DEFAULT_ERROR,a="Failed to obtain user media due to an unknown error. Error details: "+JSON.stringify(a)}return{errCode:b,errMsg:a}}function j(a){for(var b={},c=0;c<a.length;c++)b[a[c].id]=a[c].label||"Unknown device";return b}function l(a){switch(N){case c:a();break;case h:H.push(a);break;case e:H.push(a),k()}}function k(){var a=
function(){N=c;for(var a=0;a<H.length;a++)H[a]()},b=function(){window.MediaStreamTrack.getSources(function(b){z=A=!1;for(var c=n.localStorage[n._MIC_CONFIG_KEY],e=n.localStorage[n._MIC_CONFIG_KEY],f=0;f<b.length;f++){var d=b[f];u.d("Got a media source: "+JSON.stringify(d));"audio"===d.kind?(B.push(d),c===d.id&&(A=c)):"video"===d.kind&&(v.push(d),e===d.id&&(z=e))}A||(A=0<B.length?B[0].id:"");z||(z=0<v.length?v[0].id:"");n.localStorage[n._MIC_CONFIG_KEY]=A;n.localStorage[n._MIC_CONFIG_KEY]=z;a()})},
e=function(b){u.e("Failed to access media devices: "+m(b).errMsg);a()};N=h;navigator.getMedia({audio:!0,video:!0},b,function(a){a.name===n._WRTC_CONSTS.NativeErrors.DevicesNotFoundError?(u.w("No video capture device available. Video streaming will not be possible."),navigator.getMedia({audio:!0,video:!1},b,e)):e(a)})}function t(a,b){w?(G.push(b),a.result(w)):(C.push({responder:a,reqId:b}),I||(r(),I=!0))}function p(a){u.d("Got user device");w=a;K.DevicesCtrl.localStream=a;for(a=0;a<C.length;a++){var b=
C[a];t(b.responder,b.reqId)}C=[];I=!1}function q(a){u.w("Failed to get user devices due to: "+a.name);for(var a=m(a),b=0;b<C.length;b++)C[b].responder.errorAsync(a.errCode,a.errMsg);C=[];I=!1}function r(){l(function(){var a={};a.audio={optional:[{sourceId:A}]};f()?(u.d("Will use video"),a.video={mandatory:{maxWidth:n._STATIC_CONFIG.WebRTC.MAX_CAM_WIDTH,maxHeight:n._STATIC_CONFIG.WebRTC.MAX_CAM_HEIGHT,maxFrameRate:n._STATIC_CONFIG.WebRTC.MAX_CAM_FPS},optional:[{sourceId:z}]}):(u.d("Will not use video"),
a.video=!1);navigator.getMedia(a,p,q)})}function D(a){w?(a=G.indexOf(a),G.splice(a,1),G.length||s()):u.w("Got releaseUserDevice request while device is not in use")}function s(){if(w){for(var a=w.getTracks(),b=0;b<a.length;b++)a[b].stop();w=!1}}function E(){O="ADL_sample_sound"+(new Date).getTime();var a=document.createElement("audio");a.id=O;a.volume=x();a.className=M;var b=n._STATIC_CONFIG.WebRTC.SAMPLE_AUDIO_URL,c=document.createElement("source");c.src=b;var e="";/\.mp3$/.test(b)?e="audio/mpeg":
/\.ogg$/.test(b)?e="audio/ogg":/\.wav$/.test(b)&&(e="audio/wav");c.type=e;c.controls=!1;a.appendChild(c);document.body.appendChild(a)}function x(){return J/F}var n=a.ADL,K=n.MediaEngine,u,L;e="NOT_POPULATED";h="POPULATING";c="POPULATED";var F=255,M="adl-media",w=!1,y=!1,G=[],C=[],H=[],I=!1,O,J,N=e,A,z,B=[],v=[];navigator.getMedia=navigator.getUserMedia||navigator.webkitGetUserMedia||navigator.mozGetUserMedia||navigator.msGetUserMedia;window.PeerConnection=window.mozRTCPeerConnection||window.webkitRTCPeerConnection;
window.IceCandidate=window.mozRTCIceCandidate||window.RTCIceCandidate;window.SessionDescription=window.mozRTCSessionDescription||window.RTCSessionDescription;i=g=d=void 0;K.DevicesCtrl={MEDIA_CLASS:M,init:function(a,b){u=n.Log;L=K.RenderCtrl;u.d("Initializing WebRTC Devices Controller");n._videoDeviceFunctional=!0;J=F;E();var c=new n.InitStateChangedEvent(n.InitState.INITIALIZED);c.usesWebRTC=!0;var e=new n.InitProgressChangedEvent(100);a.onInitProgressChanged(new n.InitProgressChangedEvent(80));
b.initDevices?l(function(){n._videoDeviceFunctional=0<v.length;c.videoCaptureDevFunctional=n._videoDeviceFunctional;c.audioCaptureDevFunctional=0<B.length;c.audioOutputDevFunctional=!0;a.onInitProgressChanged(e);a.onInitStateChanged(c)}):setTimeout(function(){a.onInitProgressChanged(e);a.onInitStateChanged(c)},200)},dispose:function(){u.d("Disposing the Devices controller");w&&s()},getCameras:function(a){l(function(){a.resultAsync(j(v))})},getCamera:function(a){l(function(){a.resultAsync(z)})},setCamera:function(a,
b){l(function(){for(var c=0;c<v.length;c++)if(v[c].id===b){z=b;u.d("Changed camera to: "+v[c].id);n.localStorage[n._CAM_CONFIG_KEY]=b;a.resultAsync(!0);return}a.errorAsync(n.ErrorCodes.Media.INVALID_VIDEO_DEV,"Cannot set video capture device as given device id "+b+" was not found")})},getMicrophones:function(a){l(function(){a.resultAsync(j(B))})},getMicrophone:function(a){l(function(){a.resultAsync(A)})},setMicrophone:function(a,b){l(function(){for(var c=0;c<B.length;c++)if(B[c].id===b){A=b;u.d("Changed microphone to: "+
B[c].id);n.localStorage[n._MIC_CONFIG_KEY]=b;a.resultAsync(!0);return}a.errorAsync(n.ErrorCodes.Media.INVALID_AUDIO_IN_DEV,"Cannot set audio capture device as given device id "+b+" was not found")})},getSpeakers:function(a){a.resultAsync(["Speakers"])},startLocalVideo:function(a,b){f()?y?a.resultAsync(y):(a.setResultAdapter(function(a){y=L.addSink(a,!0);b.handleEvent({event:"onVideoFrameSizeChanged",params:{sinkId:y,width:n._STATIC_CONFIG.WebRTC.MAX_CAM_WIDTH,height:n._STATIC_CONFIG.WebRTC.MAX_CAM_HEIGHT}});
return y}),t(a,"localVideo")):a.errorAsync(n.ErrorCodes.Media.INVALID_VIDEO_DEV,"Cannot start local video as there is no video capture device available")},stopLocalVideo:function(a){setTimeout(function(){y&&(L.removeSink(y),D("localVideo"),y=!1);a.result()},0)},getUserDevice:t,releaseUserDevice:D,playTestSound:function(a){var b=document.getElementById(O);b.currentTime=0;b.play();a.resultAsync()},setVolume:function(a,b){0>b?b=0:b>F&&(b=F);J=b;for(var c=x(),e=document.getElementsByClassName(M),f=0;f<
e.length;f++)e[f].volume=c;a.resultAsync()},getVolume:function(a){a.resultAsync(J)},getNormalizedVolume:x,monitorMicActivity:function(a,b){if(void 0!==i)a.errorAsync(n.ErrorCodes.Logic.INVALID_STATE,"Mic activity monitoring already started");else{var c=new window.webkitAudioContext,e,f,j;navigator.getMedia({audio:!0,video:!1},function(k){j=c.createGain();e=c.createMediaStreamSource(k);e.connect(j);f=c.createAnalyser();f.fftSize=64;j.connect(f);d=f;g=b;i=window.setInterval(o,100);a.resultAsync()},
function(b){b=m(b,a);a.errorAsync(b.errCode,b.errMsg)})}},stopMonitoringMicActivity:function(a){window.clearInterval(i);i=g=d=void 0;a.resultAsync()},isVideoCaptureDeviceAvailable:f,isAudioCaptureDeviceAvailable:function(){return 0<v.length},getScreenSources:function(a,c){navigator.getMedia({video:{mandatory:{chromeMediaSource:"screen",maxWidth:c,minWidth:c}}},function(c){b(a,c)},function(b){u.w("Failed to get user devices due to: "+b.name);var c=n.ErrorCodes.Common.DEFAULT_ERROR,e="Failed to obtain user media due to an unknown error. Error details: "+
JSON.stringify(b);b.name===n._WRTC_CONSTS.NativeErrors.PERMISSION_DENIED&&(c=n.ErrorCodes.Logic.USER_CONSENT_NOT_GIVEN,e="User did not allow access to media device.");a.errorAsync(c,e)})},_localStream:w}})(window);(function(a){var d=a.ADL,g=d.MediaEngine,i;a.RTCPeerConnection=a.mozRTCPeerConnection||a.webkitRTCPeerConnection;a.IceCandidate=a.mozRTCIceCandidate||a.RTCIceCandidate;a.SessionDescription=a.mozRTCSessionDescription||a.RTCSessionDescription;g.init=function(a,h){i=d.Log;i.d("Initializing WebRTC Media Engine");a.onInitProgressChanged(new d.InitProgressChangedEvent(50));g.DevicesCtrl.init(a,h);g.ConnCtrl.init(a,h);g.AddLiveServiceWrtcImpl.init(h);g.RenderCtrl.init(a,h,g.AddLiveServiceWrtcImpl._eventsDispatcher);
d.StreamerResolver.init(h)};g.dispose=function(){g.ConnCtrl.dispose();g.RenderCtrl.dispose();g.DevicesCtrl.dispose()};g.isAvailable=function(){return!!a.webkitRTCPeerConnection};g.version="3.0.6.1005"})(window);(function(a){function d(){for(var a in m)Object.prototype.hasOwnProperty.call(m,a)&&(q=m[a],m[a].renderers.forEach(g));t&&window.requestAnimationFrame(d)}function g(a){a.cropToFill(q)}function i(a){if(a=document.getElementById("audio_"+a))a.muted=!1}function c(){for(var a in k)if(k.hasOwnProperty(a)){var b=k[a],c=m[b.sinkId];if(c.width!==b.videoNode.videoWidth||c.height!==b.videoNode.videoHeight)c.width=b.videoNode.videoWidth,c.height=b.videoNode.videoHeight,p.handleEvent({event:"onVideoFrameSizeChanged",
params:{sinkId:c.id,width:c.width,height:c.height}})}}function h(a,c){var e=document.getElementById(a.containerId);o(e);var d=document.createElement("video");if(a.fullSize){var j=document.createElement("div");j.style.width="100%";j.style.height="100%";j.style.overflow="hidden";e.appendChild(j);j.appendChild(d);this.innerContainer=j}else e.appendChild(d);a.mirror&&(d.style.transform="rotateY(180deg)",d.style.webkitTransform="rotateY(180deg)",d.style.mozTransform="rotateY(180deg)");d.src=window.URL.createObjectURL(c.stream);
d.muted=c.local;d.volume=b.DevicesCtrl.getNormalizedVolume();d.className=b.DevicesCtrl.MEDIA_CLASS;d.autoplay=!0;d.play();d.removeAttribute("controls");f.d("Rendering of sink with id: "+a.sinkId+" started");this.videoNode=d;this.container=e;this.containerH=this.containerW=0;this.sinkId=a.sinkId}var e=a.ADL,b=e.MediaEngine,f,o,m,j,l,k,t,p;a.URL=a.URL||a.webkitURL||a.mozURL||a.msURL;var q;h.prototype={cropToFill:function(a){var b=a.rWidth,c=a.rHeight,e=this.innerContainer.clientWidth,f=this.innerContainer.clientHeight;
if(!(e===this.containerW&&f===this.containerH&&b===this.videoNode.videoWidth&&c===this.videoNode.videoHeight)&&!(0===this.videoNode.videoWidth||0===this.videoNode.videoWidth)){var b=a.rWidth=this.videoNode.videoWidth,c=a.rHeight=this.videoNode.videoHeight,a=b/c,d=e/f,j=0,k=0,p="100%",g="100%";d<a?(p=Math.floor(b*(f/c)),g=f+"px",j=Math.floor(-((p-e)/2))+"px",p+="px"):d>a&&(g=Math.floor(c*(e/b)),p=e+"px",k=Math.floor(-((g-f)/2))+"px",g+="px");this.videoNode.style.width=p;this.videoNode.style.height=
g;this.videoNode.style.marginTop=k;this.videoNode.style.marginLeft=j;this.containerH=f;this.containerW=e}}};b.RenderCtrl={init:function(a,b,g){f=e.Log;o=e.Utils.removeChildNodes;f.d("Initializing the RenderCtrl");m={};k={};j=0;l="ADL_AudioContainer"+(new Date).getTime();p=g;e.Utils.embedInvisibleContainer(l);b.renderResizerEnabled&&(t=!0,window.requestAnimationFrame(d));window.setInterval(c,1E3)},dispose:function(){f.d("Disposing Render controller");for(var a in k)k.hasOwnProperty(a)&&o(k[a].container);
o(document.getElementById(l));k={};m={};t=!1},addSink:function(a,b){var c="ADLSink"+j++,b=!!b;m[c]={stream:a,local:b,renderers:[],width:0,height:0,id:c};if(!b){var e=document.getElementById(l),f=document.createElement("video");f.src=window.URL.createObjectURL(a);f.style.width=1;f.style.height=1;f.id="audio_"+c;f.style.display="none";f.autoplay=!0;e.appendChild(f);f.play()}return c},removeSink:function(a,b){if(b){var c=document.getElementById("audio_"+a);c&&c.parentNode.removeChild(c);delete m[a]}f.d("Sink with id: "+
a+" removed.")},renderSink:function(a){f.d("Rendering sink with id: "+a.sinkId);var b=document.getElementById("audio_"+a.sinkId);b&&(b.muted=!0);var b=m[a.sinkId],c=new h(a,b);b.renderers.push(c);k[a.containerId]=c},disposeRenderer:function(a){var b=k[a];if(void 0===b)f.w("Trying to dispose renderer using unknown containerId: "+a);else{var c=m[b.sinkId],a=document.getElementById(a);c&&(c.renderers.splice(c.renderers.indexOf(b)),0===c.renderers.length&&i(b.sinkId));a&&o(a);setTimeout(function(){},
200)}}}})(window);(function(a){function d(a,d,l,k,t){k=i(k);h.d("Resolving streamer endpoint. Attempt "+l+"/"+c._STATIC_CONFIG.STREAMER_RESOLVE_MAX_ATTEMPTS);var p=b[(k+l)%b.length],q={appId:f,scopeId:d.scopeId,_ts:(new Date).getTime(),version:o,authDetails:JSON.stringify(d.authDetails)};if(t){var r=d.url.split("/")[0];q.reconnect=!0;q.streamer=r}r=function(){e.doGet(g(a,d,l,k,t),p,q)};0===l%b.length?setTimeout(r,c._STATIC_CONFIG.RETRY_DELAY):r()}function g(a,b,e,f,g){return c.r(function(c){try{var e=JSON.parse(c);
b.url=e.endpoint+"/"+b.scopeId;b.turnServers=e.turnServers;b.webrtcMgmntProxy=e.webrtcMgmntProxy}catch(f){b.url=c+"/"+b.scopeId}a.result(b)},function(p,q){403===p?(h.w("Credentials probably expired - stop retrying"),a.error(c.ErrorCodes.Communication.BAD_AUTH,"CnC Rejected the signature. It is most likely expired")):e<c._STATIC_CONFIG.STREAMER_RESOLVE_MAX_ATTEMPTS?(h.w("Failed to resolve the streamer endpoint. Falling back to other resolver"),d(a,b,e+1,f,g)):a.error(p,q)})}function i(a){void 0===
a&&(a=(new Date).getTime());return a}var c=a.ADL,h=c.Log,e=null,b=[],f=NaN,o;c.StreamerResolver={init:function(a){h.d("Initializing the StreamerResolver");b=a.streamerEndpointResolver.split(c._STATIC_CONFIG.RESOLVERS_SEPARATOR);o=a.infrastructureVersion;f=a.applicationId;e=c.Utils},doResolve:function(a,b,c){d(a,b,0,void 0,c)}}})(window);(function(a){function d(a){h=c.Log;this.type=a.type;this.sdp=a.sdp;this.mediaSections=[];this.globalAttributes={};for(var b=a.sdp.split("\r\n"),a=[],d=0;d<b.length;d++)a.push({key:b[d][0],value:b[d].substring(2)});for(d=0;d<a.length;d++){var g=a[d].key,b=a[d].value;switch(g){case l:this.version=b;break;case o:this.originator=b;break;case m:this.sessionName=b;break;case j:this.time=b;break;case e:g=b.indexOf(":");g=b.substring(g+1);this.globalAttributes[b.split(":")[0]]=g;break;case f:b=new i(a,d);
d+=b.attributesCount-1;this.mediaSections.push(b);switch(b.mediaType){case "audio":break;case "video":break;default:h.w("Got unsupported media type: "+b.mediaType)}break;default:void 0!==g&&0<g.length&&h.w("Got unhandled key type when parsing SDP: "+g)}}}function g(a){return function(b,c){a.sdp+=b+"="+c+"\r\n"}}function i(a,c){var e=a[c].value.split(" ");this.attributes={};this.codecsMap={};this.codecs=[];this.SSRCs=[];this.ssrcLabels={};this.rtcpfb=[];this.iceCandidates=[];this.extmaps={};this.rtcp=
{};this.maxBandwidth=void 0;this.mediaType=e[0];this.port=e[1];this.profile=e[2];for(var d=3;d<e.length;d++)this.codecs.push(e[d]);this.connInfo=a[c+1].value;this.attributesCount=2;for(d=c+2;d<a.length;d++){var j=a[d].key,e=a[d].value;if(j===f)break;if(j===b)this.maxBandwidth=parseInt(e.replace(/AS:/,""),10);else{this.attributesCount++;var g=e.indexOf(":");if(0>g)switch(e){case "rtcp-mux":this.rtcpMux=!0;break;case "send":case "recv":case "sendrecv":case "recvonly":case "sendonly":case "inactive":this.direction=
e}else switch(j=e.substring(0,g),e=e.substring(g+1),j){case "crypto":e=e.split(" ");this.crypto={tag:e[0],hash:e[1],key:e[2].substring(7)};break;case "rtpmap":e=e.split(" ");this.codecsMap[e[0]]={id:e[0],label:e[1],options:[]};break;case "fmtp":e=e.split(" ");this.codecsMap[e[0]].options.push(e[1]);break;case "ssrc":j=e.split(" ")[0];-1===this.SSRCs.indexOf(j)&&this.SSRCs.push(j);e=e.substr(e.indexOf(" ")+1).split(":");this.ssrcLabels[j]=this.ssrcLabels[j]||{};this.ssrcLabels[j][e[0]]=e[1];break;
case "rtcp-fb":this.rtcpfb.push({payload:e.split(" ")[0],val:e.substr(e.indexOf(" ")+1)});break;case "rtcp":j=e.indexOf(" ");this.rtcp={port:e.substring(0,j),addrInfo:e.substring(j+1)};break;case "extmap":this.extmaps[e.split(" ")[1]]=e.split(" ")[0];break;case "candidate":this.iceCandidates.push(e);break;default:this.attributes[j]=e}}}}var c=a.ADL,a=c.MediaEngine,h,e="a",b="b",f="m",o="o",m="s",j="t",l="v";d.prototype={serialize:function(){return JSON.stringify({sdp:this.sdp,type:this.type})},flush:function(){var a,
b={sdp:""},c=g(b);c(l,0);c(o,this.originator);c(m,this.sessionName);c(j,this.time);for(a in this.globalAttributes)if(Object.prototype.hasOwnProperty.call(this.globalAttributes,a)){var d=this.globalAttributes[a];""!==d&&(d=":"+d);c(e,a+d)}for(a=0;a<this.mediaSections.length;a++)this.mediaSections[a].serialize(c);this.sdp=b.sdp},toRtcSessionDescription:function(){return new window.SessionDescription(this)},overwriteMsidLabels:function(a){if(2!==this.mediaSections.length)throw h.e("overwriteMsidLabels() supports only peer connection with both audio and video present (not more, not less)"),
new c.AddLiveException("overwriteMsidLabels() supports only peer connection with both audio and video present (not more, not less)",c.ErrorCodes.Logic.INVALID_ARGUMENT);a=a||c.Utils.randomString(36);this.globalAttributes["msid-semantic"]="WMS "+a;for(var b=0;b<this.mediaSections.length;b++)this.mediaSections[b].overwriteMsidLabels(a)},mediaOrSessionAttr:function(a,b){return this.mediaSections[b].attributes[a]||this.globalAttributes[a]},getCryptoParams:function(){return{fingerprints:[this.mediaOrSessionAttr("fingerprint",
0),this.mediaOrSessionAttr("fingerprint",this.mediaSections.length-1)]}},getIceUfrags:function(){return void 0!==this.globalAttributes["ice-ufrag"]?[this.globalAttributes["ice-ufrag"],this.globalAttributes["ice-ufrag"]]:[this.mediaSections[0].attributes["ice-ufrag"],this.mediaSections[this.mediaSections.length-1].attributes["ice-ufrag"]]},getIcePwds:function(){return void 0!==this.globalAttributes["ice-pwd"]?[this.globalAttributes["ice-pwd"],this.globalAttributes["ice-pwd"]]:[this.mediaSections[0].attributes["ice-pwd"],
this.mediaSections[0].attributes["ice-pwd"]]},getAudioCname:function(){return this.mediaSections[0].getCNAME()},isBundledMedia:function(){return void 0!==this.globalAttributes.group&&-1!==this.globalAttributes.group.indexOf("BUNDLE")},getAuthResponseDetails:function(){return{iceUfrags:this.getIceUfrags(),icePwds:this.getIcePwds(),cryptoParams:this.getCryptoParams(),cname:this.getAudioCname()}}};d.fromString=function(a){return new d(JSON.parse(a))};d.HeaderExtensions={SSRC_AUDIO_LEVEL:"urn:ietf:params:rtp-hdrext:ssrc-audio-level",
TOFFSET:"urn:ietf:params:rtp-hdrext:toffset",ABS_SEND_TIME:"http://www.webrtc.org/experiments/rtp-hdrext/abs-send-time"};i.prototype={serialize:function(a){var c,d;c=this.mediaType+" "+this.port+" "+this.profile+" ";c+=this.codecs.join(" ");a(f,c);a("c",this.connInfo);this.maxBandwidth&&a(b,"AS:"+this.maxBandwidth);for(d in this.attributes)Object.prototype.hasOwnProperty.call(this.attributes,d)&&a(e,d+":"+this.attributes[d]);this.direction&&0<this.direction.length&&a(e,this.direction);void 0!==this.rtcp.port&&
a(e,"rtcp:"+this.rtcp.port+" "+this.rtcp.addrInfo);this.rtcpMux&&a(e,"rtcp-mux");this.crypto&&a(e,"crypto:"+this.crypto.tag+" "+this.crypto.hash+" inline:"+this.crypto.key);for(d in this.extmaps)Object.prototype.hasOwnProperty.call(this.extmaps,d)&&a(e,"extmap:"+this.extmaps[d]+" "+d);for(c=0;c<this.codecs.length;c++){var j=this.codecsMap[this.codecs[c]];a(e,"rtpmap:"+j.id+" "+j.label);for(d=0;d<j.options.length;d++)a(e,"fmtp:"+j.id+" "+j.options[d]);for(d=0;d<this.rtcpfb.length;d++)this.rtcpfb[d].payload===
j.id&&a(e,"rtcp-fb:"+j.id+" "+this.rtcpfb[d].val)}var g=this;this.SSRCs.forEach(function(b){for(var c in g.ssrcLabels[b])Object.prototype.hasOwnProperty.call(g.ssrcLabels[b],c)&&a(e,"ssrc:"+b+" "+c+":"+g.ssrcLabels[b][c])});for(c=0;c<this.iceCandidates.length;c++)a(e,"candidate:"+this.iceCandidates[c])},setCodecByPayload:function(a){if(-1===this.codecs.indexOf(""+a))throw a="Payload type "+a+" is not present in payload list: "+JSON.stringify(this.codecs),h.e(a),new c.AddLiveException(a,c.ErrorCodes.Logic.INVALID_ARGUMENT);
this.codecs=[a]},setCodecByName:function(a){var b,c=-1;for(b in this.codecsMap)if(Object.prototype.hasOwnProperty.call(this.codecsMap,b)&&this.codecsMap[b].label===a){c=this.codecsMap[b].id;break}-1!==c?this.codecs=[c]:window.console.error("Failed to find codec with label "+a)},setFec:function(){this.codecsMap[116]={id:116,label:"red/90000",options:[]};this.codecs.push(116);this.codecsMap[117]={id:117,label:"ulpfec/90000",options:[]};this.codecs.push(117)},overwriteMsidLabels:function(a){var b,e=
a,d=this;this.SSRCs.forEach(function(a){b="audio"===d.mediaType?e+"a0":e+"v0";d.ssrcLabels[a].msid=e+" "+b;d.ssrcLabels[a].mslabel=e;d.ssrcLabels[a].label=b;e=c.Utils.randomString(36)})},getCNAME:function(){return 0<this.SSRCs.length?this.ssrcLabels[this.SSRCs[0]].cname:""},removeGoogleRemb:function(){for(var a=this.rtcpfb.length-1;0<=a;a--)"goog-remb"===this.rtcpfb[a].val&&this.rtcpfb.splice(a,1)},removeNack:function(){for(var a=this.rtcpfb.length-1;0<=a;a--)"nack"===this.rtcpfb[a].val.split(" ")[0]&&
this.rtcpfb.splice(a,1)},overwriteSSRC:function(a,b){this.ssrcLabels[b]=this.ssrcLabels[a];this.SSRCs.push(b);this.SSRCs.splice(this.SSRCs.indexOf(a),1);delete this.ssrcLabels[a]}};a.ManageableSDP=d})(window);(function(a){function d(a){i=g.Log;i.d("Initializing the Connectivity controller");c=g.Utils.bind;this.state=d.State.CREATED;this.listener=a;this.msgsQueue=[]}var g=a.ADL,a=g.MediaEngine,i,c,h={CONNECTION_STATUS:1,STREAMING_STATUS:2,HEARTBEAT:3,P2P_MODE_TOGGLE:6,USER_MESSAGE:7,NEW_DOWNLINK_RESPONSE:8,P2P_CANDIDATE_READY:9,STREAMER_ERROR:10};d._EVENT_2_HANDLER={};d._EVENT_2_HANDLER[1]="_onAuthResponse";d._EVENT_2_HANDLER[3]="_onUserEvent";d._EVENT_2_HANDLER[4]="_onMediaEvent";d.State={CREATED:"CREATED",
CONNECTING:"CONNECTING",AWAITING:"AWAITING",CONNECTED:"CONNECTED",TERMINATED:"TERMINATED"};d.prototype={connect:function(a,b){this.proxyUrl=b;i.d("Trying to establish management connection to the webrtc proxy: "+this.proxyUrl);this.responder=a;this.state=d.State.CONNECTING;this.socket=new WebSocket(this.proxyUrl);this.socket.onopen=c(this._onSockOpen,this);this.socket.onmessage=c(this._onSockMessage,this);this.socket.onerror=c(this._onSockError,this);this.socket.onclose=c(this._onSockClose,this)},
sendAuthReq:function(a,b){var c={_msgClass:"clientMessage",msgType:1,authRequest:{_msgClass:"authRequest",_streamerHost:b.streamerAddr,audioPublished:b.audioPublished,videoPublished:b.videoPublished,clientVersion:"3.0.0.0",receiveLowVideoStream:!0,receiveHighVideoStream:!1,sdkType:5,authDetails:b.authDetails,isBundledMedia:!0,bundleIceCredentials:{_msgClass:"iceCredentials",ufrag:b.iceUfrags[0],pwd:b.icePwds[0]},fingerprint:b.cryptoParams.fingerprints[0],cname:b.cname}};c.authRequest.authDetails._msgClass=
"authDetails";c.authRequest.authDetails.applicationId=b.appId;this.scopeId=c.authRequest.authDetails.scopeId=b.scopeId;this.userId=b.authDetails.userId;this.authResponseResponder=a;i.d("[MgmntConn] = Sending Auth request: "+JSON.stringify(c));this._sendMsg(c)},mediaReady:function(){var a=this;this.state=d.State.CONNECTED;this.msgsQueue.forEach(function(b){a._onSockMessage(b)})},downlinkConnectionResponse:function(a,b){this._sendMsg({_msgClass:"clientMessage",msgType:4,userEvent:{_msgClass:"userEvent",
type:h.NEW_DOWNLINK_RESPONSE,userId:a,bundleIceCredentials:{_msgClass:"iceCredentials",ufrag:b.iceUfrags[0],pwd:b.icePwds[0]},fingerprint:b.cryptoParams.fingerprints[0]}})},publishConfigUpdated:function(a){a={_msgClass:"clientMessage",msgType:4,userEvent:{_msgClass:"userEvent",type:h.STREAMING_STATUS,userId:a.userId,remoteVideoSsrc0:a.videoSsrc,remoteVideoSsrc1:a.videoSsrc+1,remoteAudioSsrc:a.audioSsrc,audioPublished:a.audioPublished,videoPublished:a.videoPublished,screenPublished:!1}};i.d("[MgmntConn] = Sending media publish status message: "+
JSON.stringify(a));this._sendMsg(a)},sendMessage:function(a,b){var c={_msgClass:"clientMessage",msgType:4,userEvent:{_msgClass:"userEvent",type:h.USER_MESSAGE,userMessage:a,scopeId:this.scopeId}};void 0!==b&&(c.userEvent.userId=b);this._sendMsg(c)},publishUplinkStats:function(a,b){var c={_msgClass:"clientMessage",msgType:5,mediaEvent:{_msgClass:"mediaEvent",eventType:4,mediaTransportType:1}};a===g.MediaType.AUDIO?(b._msgClass="audioUplinkStats",c.mediaEvent.type=0,c.mediaEvent.pushAudioStats={audioUplinkStats:b,
_msgClass:"mediaEventPushAudioStats"}):(b._msgClass="videoUplinkStats",c.mediaEvent.type=1,c.mediaEvent.pushVideoStats={videoUplinkStats:b,_msgClass:"mediaEventPushVideoStats"});this._sendMsg(c)},sendBitRateChangeRequest:function(a){this._sendMsg({_msgClass:"clientMessage",msgType:5,mediaEvent:{_msgClass:"mediaEvent",type:1,eventType:0,setVideoBitrate:{_msgClass:"mediaEventSetVideoBitrate",videoBitrate:a}}})},updateAvailLayers:function(a,b){var c={_msgClass:"clientMessage",msgType:5,mediaEvent:{_msgClass:"mediaEvent",
type:1,updateVideoLayer:{_msgClass:"mediaEventUpdateVideoLayer",videoLayer:a}}};c.mediaEvent.eventType=b?1:2;this._sendMsg(c)},disconnect:function(){clearTimeout(this.keepAliveTimeoutId);this.socket.close();this.state=d.State.TERMINATED},_onSockOpen:function(){i.d("Socket connection to proxy: "+this.proxyUrl+" succeded");this.responder.result();delete this.responder},_onSockError:function(){i.w("Got Mgmnt socket error");if(void 0!==this.responder)this.responder.error(g.ErrorCodes.Communication.NETWORK_ERROR,
"Failed to establish management connection");else this.listener.onConnectionLost(g.ErrorCodes.Communication.NETWORK_ERROR,"Management connection lost");this.stateError=!0},_onSockClose:function(){i.w("Got Mgmnt socket closed");if(!this.stateError)this.listener.onConnectionLost(g.ErrorCodes.Communication.NETWORK_ERROR,"Management connection lost")},_onSockMessage:function(a){a.queued?i.d("Processing queued server side message: "+a.data):i.d("Got raw message from the streaming server: "+a.data);if(this.state===
d.State.AWAITING)i.d("The management connection awaits for media streams to be ready. The message will be queued."),this.msgsQueue.push({data:a.data,queued:!0});else{var a=JSON.parse(a.data),b=d._EVENT_2_HANDLER[a.msgType];if(void 0!==this[b])this[b](a);else i.w("Cannot handle streamer's management event of type: "+a.msgType+" as the even handler is not defined")}},_keepAliveTimer:function(){this._sendMsg({_msgClass:"clientMessage",msgType:4,userEvent:{_msgClass:"userEvent",type:h.HEARTBEAT,userId:this.userId,
scopeId:this.scopeId,requestsHBReply:!0}});this.keepAliveTimeoutId=setTimeout(c(this._keepAliveTimer,this),5E3)},_sendMsg:function(a){a=JSON.stringify(a);i.d("Sending management message to the streamer:\n"+a);this.socket.send(a)},_onAuthResponse:function(a){a=a.authResponse;0===a.status?(this.authResponseResponder.result(a),this._keepAliveTimer(),this.state=d.State.AWAITING):(this.disconnect(),this.authResponseResponder.error(g.ErrorCodes.Communication.NETWORK_ERROR))},_onUserEvent:function(a){switch(a.userEvent.type){case h.CONNECTION_STATUS:this.listener.onRemoteConnectionStatus(a.userEvent);
break;case h.STREAMING_STATUS:this.listener.onRemoteStreamingStatus(a.userEvent);break;case h.USER_MESSAGE:this.listener.onRemoteMessage(a.userEvent);break;case h.STREAMER_ERROR:i.w("Got streamer error: "+JSON.stringify(a));var b=g.ErrorCodes.Communication.NETWORK_ERROR,c=a.userEvent.streamerErrorMsg;2015===a.userEvent.streamerErrorCode&&(b=g.ErrorCodes.Communication.NEW_USER_CONNECTION);this.listener.onConnectionLost(b,c);this.stateError=!0}},_onMediaEvent:function(a){this.listener.onMediaEvent(a.mediaEvent)}};
a.MgmntConnection=d;a.UserEventType=h})(window);(function(a){var d;function g(a,g,k,i){void 0===e&&(e=c.Log,b=c.ErrorCodes.Communication,o=h.WrtcUplinkConn,m=h.WrtcDownlinkConn,f=h.MgmntConnection);this.connDescr=a;this.proxyUrl=a.webrtcMgmntProxy;this.defaultProxyUrl=g;this.scopeId=a.scopeId;this.localUserId=a.authDetails.userId;this.listener=k;this.audioPublished=a.autopublishAudio;this.videoPublished=a.autopublishVideo;this.appId=i;this.state=d;this.maxBitRateAchieved=this.statsPushIntervalId=0;this._createConnections()}function i(a,b,d){return c.r(function(e){a.handleEvent({event:"onMediaStats",
params:{scopeId:b,remoteUserId:d,mediaType:c.MediaType.AUDIO,stats:e.audio}});a.handleEvent({event:"onMediaStats",params:{scopeId:b,remoteUserId:d,mediaType:c.MediaType.VIDEO,stats:e.video}})})}var c=a.ADL,h=c.MediaEngine,e,b,f,o,m;d="CREATED";g.prototype={connect:function(a){e.d("Connecting to scope: "+this.scopeId);this.responder=a;this.state="CONNECTING";this._resolveStreamer();this._connectionTimeout=setTimeout(c.Utils.bind(this._handleConnectionTimeout,this),c._STATIC_CONFIG.WebRTC.CONNECT_TIME_MAX)},
publish:function(a,b){this._applyStreamingChange(a,b,!0);b===c.MediaType.VIDEO&&this.mgmntConn.updateAvailLayers(0,!0)},unpublish:function(a,b){this._applyStreamingChange(a,b,!1);b===c.MediaType.VIDEO&&this.mgmntConn.updateAvailLayers(0,!1)},disconnect:function(a){"RECONNECTING"===this.state||void 0===this.mgmntConn?(clearTimeout(this._reconnectTimeout),this.state="DISCONNECTED"):(this.state="DISCONNECTED",this.mgmntConn.disconnect(),this.upstreamMediaConn.close(),c.Utils.forEach(this.downstreamMediaConns,
function(a,b){b.close()}),window.clearInterval(this.statsPushIntervalId),h.DevicesCtrl.releaseUserDevice("scope-"+this.scopeId),delete this.downstreamMediaConns,delete this.mgmntConn,delete this.upstreamMediaConn);a.resultAsync()},sendMessage:function(a,b,c){this.mgmntConn.sendMessage(b,c);a.resultAsync()},publishStats:function(a){var b=this;this.upstreamMediaConn.getStats(i(a,this.scopeId,void 0));c.Utils.forEach(this.downstreamMediaConns,function(c,d){d.getStats(i(a,b.scopeId,c))})},reconfigureVideo:function(a){this.connDescr.readOnly||
(a=2.82118E-4*a.maxWidth*a.maxHeight*a.maxFps,a>c._STATIC_CONFIG.WebRTC.MAX_VIDEO_BITRATE?a=c._STATIC_CONFIG.WebRTC.MAX_VIDEO_BITRATE:50>a&&(a=50),a=Math.floor(a),this.mgmntConn.sendBitRateChangeRequest(1E3*a),this.upstreamMediaConn.renegotiateUpstreamBitRate(Math.min(a,this.maxBitRateAchieved)))},onRemoteConnectionStatus:function(a){a.status?this._addRemotePeer(a):this._removeRemotePeer(a)},onRemoteStreamingStatus:function(a){var b=this,d=this.downstreamMediaConns[a.userId],e;a.audioPublished!==
d.audioEnabled?e=c.MediaType.AUDIO:a.videoPublished!==d.videoEnabled?e=c.MediaType.VIDEO:a.screenPublished!==d.screenEnabled&&(e=c.MediaType.SCREEN);var f=function(){a.mediaType=e;a.videoSinkId=d.videoSinkId;a.screenSinkId=d.screenSinkId;b.listener.handleEvent({event:"onMediaStreamEvent",params:{scopeId:b.scopeId,userDetails:a,mediaType:e}});d.onRemoteStreamReady=false},g=!1;if(e===c.MediaType.VIDEO&&a.videoPublished||e===c.MediaType.SCREEN&&a.screenPublished)d.onRemoteStreamReady=f,g=!0;d.renegotiateEnabledStreams(a.audioPublished,
a.videoPublished,a.screenPublished);g||f()},onRemoteMessage:function(a){this.listener.handleEvent({event:"onMessage",params:{scopeId:this.scopeId,srcUserId:a.userId,data:a.userMessage}})},onMediaEvent:function(a){e.d("Got media event: "+JSON.stringify(a))},onConnectionLost:function(a,b){"CONNECTED"===this.state&&(this.disconnect(c.nR("disconnect")),this.state="RECONNECTING",this._createConnections(),this._setupReconnect(),h.ConnCtrl._connLost(this.scopeId,!1),this.listener.handleEvent({event:"onConnectionLost",
params:{scopeId:this.scopeId,errCode:a,errMessage:b,willReconnect:!0}}))},_applyStreamingChange:function(a,b,d){switch(b){case c.MediaType.AUDIO:if(this.audioPublished===d){e.w("Trying to publish audio even tough it's already published");a.resultAsync();return}this.audioPublished=d;break;case c.MediaType.VIDEO:if(this.videoPublished===d){e.w("Trying to publish video even tough it's already published");a.resultAsync();return}this.videoPublished=d}this.mgmntConn.publishConfigUpdated({userId:this.localUserId,
audioSsrc:this.upstreamMediaConn.audioSsrc,videoSsrc:this.upstreamMediaConn.videoSsrc,audioPublished:this.audioPublished,videoPublished:this.videoPublished});this.upstreamMediaConn.renegotiateEnabledStreams(this.audioPublished,this.videoPublished);a.resultAsync()},_resolveStreamer:function(){var a=this,b=function(b){a.connDescr=b;a.proxyUrl||(a.proxyUrl=b.webrtcMgmntProxy);a.proxyUrl||(a.proxyUrl=a.defaultProxyUrl);a._connectToWebrtcProxy()},d=function(){a.responder.error(c.ErrorCodes.Communication.NETWORK_ERROR,
"Failed to connect to AddLive service most likely due to Internet outage or firewall blocking HTTP communication")};this.connDescr.url?b(this.connDescr):(b=c.r(b,d),b.setMethod("StreamerResolver.doResolve()"),c.StreamerResolver.doResolve(b,this.connDescr,!1))},_connectToWebrtcProxy:function(){var a=this,d=c.r(function(){e.d("Management connection connected");a.connDescr.readOnly?a._sendAuthRequest({iceUfrags:["123321123"],icePwds:["123321"],cryptoParams:{fingerprints:["sha-256 35:0E:4B:4B:C5:A3:DC:17:9C:8A:73:D7:19:6B:04:8D:33:0F:A9:A8:B0:0B:2E:3F:CC:25:7B:11:1F:2F:27:44"]},
cname:"Some non empty Cname"}):a._getUserDevice()},function(){e.w("There was an error connecting to the websocket proxy. No Internet connectivity? Proxy down?");a.responder.error(b.NETWORK_ERROR,"There was an error connecting to the websocket proxy. No Internet connectivity? Proxy down?")});d.setMethod("MgmntConnection#connect()");this.mgmntConn.connect(d,this.proxyUrl)},_getUserDevice:function(){var a=this,b=c.r(function(b){e.d("Management connection connected");a._connectMediaUpstream(b)},function(){e.w("There was an error requesting the device");
a.responder.error(c.ErrorCodes.Media.INVALID_VIDEO_DEV,"There was an error requesting the device")});b.setMethod("DevicesCtrl.getUserDevice");h.DevicesCtrl.getUserDevice(b,"scope-"+this.scopeId)},_connectMediaUpstream:function(a){var b=this,d=c.r(function(a){e.d("Management connection connected");b._sendAuthRequest(a)},function(){e.w("There was an error preparing upstream media connection");b.responder.error(c.ErrorCodes.Communication.MEDIA_LINK_FAILURE,"There was an error preparing upstream media connection")});
d.setMethod("WrtcMediaConn#connect");this.upstreamMediaConn.createOffer(d,a,{audio:this.audioPublished,video:this.videoPublished})},_sendAuthRequest:function(a){var b=this,d={userId:this.connDescr.authDetails.userId,scopeId:this.scopeId,appId:this.appId,streamerAddr:this.connDescr.url.split("/")[0],audioPublished:this.connDescr.autopublishAudio,videoPublished:this.connDescr.autopublishVideo,authDetails:this.connDescr.authDetails},d=c.Utils.merge(d,a),a=c.r(function(a){b._handleAuthResponse(a)},function(a,
c){b.responder.error(a,c)});a.setMethod("MgmntConnection#sendAuthReq");this.mgmntConn.sendAuthReq(a,d)},_handleAuthResponse:function(a){var b=this;this.connDescr.readOnly?this.mediaUplinkReady=!0:this.upstreamMediaConn.connect(c.r(function(){b._handleMediaUplinkReady()}),a);this.authResponse=a;this.mgmntReady=!0;this._dispatchConnectionSuccMaybe()},_handleMediaUplinkReady:function(){this.mediaUplinkReady=!0;this._dispatchConnectionSuccMaybe()},_dispatchConnectionSuccMaybe:function(){if(this.mediaUplinkReady&&
this.mgmntReady&&"CONNECTED"!==this.state){clearTimeout(this._connectionTimeout);this.responder.resultAsync();this.responder=null;this.state="CONNECTED";var a=this;setTimeout(function(){a.mgmntConn.mediaReady();a.listener.handleEvent({event:"onMediaConnTypeChanged",params:{scopeId:a.scopeId,mediaType:c.MediaType.AUDIO,connectionType:c.ConnectionType.UDP_RELAY}});a.listener.handleEvent({event:"onMediaConnTypeChanged",params:{scopeId:a.scopeId,mediaType:c.MediaType.VIDEO,connectionType:c.ConnectionType.UDP_RELAY}});
a.connDescr.readOnly||(e.d("Starting stats push interval"),a.statsPushIntervalId=window.setInterval(function(){e.d("Pushing stats");a._statsPublisher()},c._STATIC_CONFIG.WebRTC.STATS_PUBLISH_INTERVAL));a.mgmntConn.updateAvailLayers(0,a.connDescr.autopublishVideo)},100)}},_handleConnectionTimeout:function(){this.disconnect(c.nR("disconnect()"));var a="Failed to connect as connection timeout occured. Failed to establish following connection components: ";this.mgmntReady||(a+="management connection ");
this.mediaUplinkReady||(a+=" media uplink connection");this.responder.errorAsync(c.ErrorCodes.Communication.NETWORK_ERROR,a)},_addRemotePeer:function(a){if(!this.connDescr.readOnly||a.videoPublished||a.audioPublished){var b=this,d=new m(a.userId,this.scopeId,this.connDescr.turnServers),f=c.r(function(c){e.d("Management connection connected");b.mgmntConn.downlinkConnectionResponse(a.userId,c);d.connect(g,b.authResponse)}),g=c.r();f.setMethod("WrtcMediaConn#setupForDownstream");g.setMethod("WrtcMediaConn#connectedForDownlink");
this.downstreamMediaConns[a.userId]=d;d.onRemoteStreamReady=function(){e.d("Got remote stream ready.");b.listener.handleEvent({event:"onUserEvent",params:{scopeId:b.scopeId,userDetails:{id:a.userId,isConnected:!0,videoPublished:a.videoPublished,audioPublished:a.audioPublished,screenPublished:a.screenPublished,videoSinkId:d.videoSinkId,screenSinkId:d.screenSinkId}}});d.onRemoteStreamReady=void 0};d.createOffer(f,a)}},_removeRemotePeer:function(a){this.downstreamMediaConns[a.userId].close();delete this.downstreamMediaConns[a.userId];
this.listener.handleEvent({event:"onUserEvent",params:{scopeId:this.scopeId,userDetails:{id:a.userId,isConnected:!1}}})},_createConnections:function(){this.mgmntConn=new f(this,this.proxyUrl);this.connDescr.readOnly||(this.upstreamMediaConn=new o(this.connDescr.scopeId,this.connDescr.turnServers));this.downstreamMediaConns={}},_setupReconnect:function(){var b=c._STATIC_CONFIG.RECONNECT_MIN_INTERVAL,d=c._STATIC_CONFIG.RECONNECT_MAX_INTERVAL,b=b+Math.random()%(d-b);e.d("Will attempt to reconnect after "+
b);this._reconnectTimeout=a.setTimeout(c.Utils.bind(this._reconnect,this),1E3*b)},_reconnect:function(){e.i("Trying to reconnect session with id: "+this.scopeId);var a=c.r(c.Utils.bind(this._onNewURL,this),c.Utils.bind(this._onConnError,this));a.setMethod("StreamerResolver.doResolve");c.StreamerResolver.doResolve(a,this.connDescr,!0)},_onNewURL:function(a){this.connDescr=a;this.responder=c.r(c.Utils.bind(this._onConnected,this),c.Utils.bind(this._onConnError,this));this._connectToWebrtcProxy()},_onConnected:function(){e.i("Session with id: "+
this.scopeId+" successfully reconnected");this.state="CONNECTED";this.listener.handleEvent({event:"onSessionReconnected",params:{scopeId:this.scopeId}})},_onConnError:function(a){e.w("Failed to reconnect session with id: "+this.scopeId);a===c.ErrorCodes.Communication.BAD_AUTH?(this.disconnect(c.nR("disconnect()")),this.state="DISCONNECTED",this.listener.handleEvent({event:"onConnectionLost",params:{scopeId:this.scopeId,errCode:a,errMessage:"An attempt to reconnect failed as the authentication signature provided during connection setup has expired",
willReconnect:!1}}),h.ConnCtrl._connLost(this.scopeId,!0)):this._setupReconnect()},_statsPublisher:function(){var a=this;this.upstreamMediaConn.getStats(c.r(function(b){var d,e;if(b.audio){d={ssrc:a.upstreamMediaConn.audioSsrc,timestamp:(new Date).getTime()/1E3,kbps:b.audio.totalKbps,rtt:b.audio.rtt,cumLoss:0,fracLoss:0};for(e in d)d.hasOwnProperty(e)&&(d[e]=parseInt(d[e],10));a.mgmntConn.publishUplinkStats(c.MediaType.AUDIO,[d])}if(b.video){b={ssrc:a.upstreamMediaConn.videoSsrc,timestamp:d.timestamp,
layer:1,kbps:b.video.totalKbps,totalKbps:b.video.totalKbps,cpu:0,totalCpu:0,fps:b.video.fps,psnr:0,rtt:d.rtt,cumLoss:0,fracLoss:0,qdl:0,width:b.video.frameWidth,height:b.video.frameHeight};for(e in b)b.hasOwnProperty(e)&&(b[e]=parseInt(b[e],10));a.maxBitRateAchieved=Math.max(a.maxBitRateAchieved,b.kbps);a.mgmntConn.publishUplinkStats(c.MediaType.VIDEO,[b])}}))}};h.ScopeConnection=g})(window);(function(a){function d(){e||(e=c.Log,b=h.ManageableSDP,f=h.WrtcConnHelper)}function g(a,b){d();e.d("[MU] = Creating new instance of the WrtcUplinkConn");d();f.applyBaseWrtConnMixin(this);this.initCommon(a,b);this.maxUplinkRate=c._STATIC_CONFIG.WebRTC.MAX_VIDEO_BITRATE}function i(a,b,c){a.rtt=parseInt(b.googRtt||b.mozRtt||0,10);c&&(a.totalKbps=8*((b.bytesSent-c.bytesSent)/((b.timestamp-c.timestamp)/1E3))/1024)}var c=a.ADL,h=c.MediaEngine,e,b,f;g.prototype={createOffer:function(a,b,c){e.d("[MU] = Preparing an offer");
this.audioEnabled=c.audio;this.videoEnabled=c.video;this._createOffer(a,{mandatory:{OfferToReceiveAudio:!1,OfferToReceiveVideo:!1}},b)},connect:function(a,b){e.d("[MU] = Handling auth response");var c={localMediaDirections:[f.getSenderDirection(this.audioEnabled),f.getSenderDirection(this.videoEnabled)],remoteMediaDirections:[f.getReceiverDirection(this.audioEnabled),f.getReceiverDirection(this.videoEnabled)]};this._connectCommon(a,b,c)},close:function(){e.d("[MU] = Closing a connection");this.tearDownCommon()},
renegotiateUpstreamBitRate:function(a){e.d("Setting new max uplink rate: "+a);if(!a||a>c._STATIC_CONFIG.WebRTC.MAX_VIDEO_BITRATE)a=c._STATIC_CONFIG.WebRTC.MAX_VIDEO_BITRATE;this.maxUplinkRate=a;this._doRenegotiateMedia()},_adjustOffer:function(a){this._adjustOfferMediaSectionCommon(a);this.offerSdp.flush();return this.offerSdp.toRtcSessionDescription()},_adjustAnswer:function(a,c){var d=new b(c),e;d.type="answer";d.originator="relay 20518 0 IN IP4 "+a.address;d.globalAttributes["end-of-candidates"]=
"";d.globalAttributes["ice-lite"]="";d.globalAttributes.fingerprint=a.fingerprint;for(e=0;e<d.mediaSections.length;e++)this._setStreamerEndpointParamsMediaSection(d.mediaSections[e],a,e);d.globalAttributes["msid-semantic"]="WMS";d.globalAttributes.fingerprint=a.fingerprint;for(e=0;e<d.mediaSections.length;e++)d.mediaSections[e].direction=a.remoteMediaDirections[e],d.mediaSections[e].ssrcLabels={},delete d.mediaSections[e].attributes.fingerprint,d.mediaSections[e].crypto=void 0;d.flush();return d.toRtcSessionDescription()},
_doRenegotiateMedia:function(){e.d("[MU] = changing media publishing status");var a=new b(this._nativePC.localDescription),d=new b(this._nativePC.remoteDescription);a.mediaSections[0].direction=f.getSenderDirection(this.audioEnabled);1<a.mediaSections.length&&(a.mediaSections[1].direction=f.getSenderDirection(this.videoEnabled),e.d("Setting max bitrate: "+this.maxUplinkRate),a.mediaSections[1].maxBandwidth=this.maxUplinkRate,c._STATIC_CONFIG.WebRTC.USE_NACK||a.mediaSections[1].removeNack(),c._STATIC_CONFIG.WebRTC.USE_FEC&&
(e.d("enabling FEC"),a.mediaSections[1].setFec()));a.flush();d.mediaSections[0].direction=f.getReceiverDirection(this.audioEnabled);1<a.mediaSections.length&&(d.mediaSections[1].direction=f.getReceiverDirection(this.videoEnabled),d.mediaSections[1].maxBandwidth=this.maxUplinkRate);d.flush();this._setOfferAndAnswer(a.toRtcSessionDescription(),d.toRtcSessionDescription())},_translateStats:function(a){e.d("Got media stats reports: "+a);for(var b,c,a=a.result(),d=0;d<a.length;d++){var f=a[d];if(/^ssrc/.test(f.id)){for(var g=
{},h=f.names(),q=0;q<h.length;q++)g[h[q]]=f.stat(h[q]);g.timestamp=f.timestamp.getTime();parseInt(g.ssrc,10)===parseInt(this.audioSsrc,10)?b=g:parseInt(g.ssrc,10)===parseInt(this.videoSsrc,10)&&(c=g)}}void 0!==c&&(b.googRtt=c.googRtt);a=b;d=this.prevAudioStats;f={totalKbps:0,cumulativePacketLoss:0,fractionLost:0,rtt:0,timestamp:0,bufferLength:0};a.interarrivalJitter=a.googJitterReceived||0;i(f,a,d,void 0);a={audio:f};void 0!==c&&(d=c,f={totalKbps:0,cumulativePacketLoss:0,fractionLost:0,rtt:0,timestamp:0,
cpu:0,totalCpu:0,fps:0,processingTime:0,psnr:0,qdl:0,avOffset:0},i(f,d,this.prevVideoStats,void 0),f.fps=d.googFrameRateSent||d.mozFrameRateSent||0,f.frameWidth=d.googFrameWidthSent||d.mozFrameWidthSent||0,f.frameHeight=d.googFrameHeightSent||d.mozFrameHeightSent||0,a.video=f);this.prevAudioStats=b;this.prevVideoStats=c;return a}};h.WrtcUplinkConn=g})(window);(function(a){var d,g,i,c;function h(a,b,c){m||(m=f.Log,j=o.ManageableSDP,l=o.WrtcConnHelper);m.d("[MD] = Creating new instance of the WrtcDownlinkConn");l.applyBaseWrtConnMixin(this);this.initCommon(b,c);this.userId=a;this.onRemoteStreamReady=!1}function e(a){a=a.getTracks();if(0===a.length)return d;if(2===a.length)return g;if("audio"===a[0].kind)return i;if("video"===a[0].kind)return c}function b(a,b,c){a.cumulativePacketLoss=b.packetsLost;c&&(a.totalKbps=8*((b.bytesReceived-c.bytesReceived)/((b.timestamp-
c.timestamp)/1E3))/1024)}var f=a.ADL,o=f.MediaEngine,m,j,l;h.prototype={createOffer:function(a,b){m.d("[MD] = Preparing an offer for user "+b.userId);this.audioEnabled=b.audioPublished;this.videoEnabled=b.videoPublished;this.screenEnabled=b.screenPublished;this.userJoinedEvent=b;this._createOffer(a,{mandatory:{OfferToReceiveAudio:!0,OfferToReceiveVideo:!0}},!1)},connect:function(a,b){m.d("[MD] = Connecting for user "+this.userId);var c=this._getDirections();this.rawNetworkInfo={audioIceCandidates:b.audioIceCandidates,
videoIceCandidates:b.videoIceCandidates,bundleIceCandidate:b.bundleIceCandidate,fingerprint:this.userJoinedEvent.fingerprint,bundleIceCredentials:this.userJoinedEvent.bundleIceCredentials,localAudioSsrc:this.userJoinedEvent.localAudioSsrc,localVideoSsrc0:this.userJoinedEvent.localVideoSsrc0,remoteAudioSsrc:this.userJoinedEvent.remoteAudioSsrc,remoteVideoSsrc0:this.userJoinedEvent.remoteVideoSsrc0,remoteScreenSsrc:this.userJoinedEvent.remoteScreenSsrc};this._connectCommon(a,this.rawNetworkInfo,c)},
close:function(){m.d("[MD] = Closing a connection");void 0!==this.sinkId&&o.RenderCtrl.removeSink(this.videoSinkId,!0);this.tearDownCommon()},getStats:function(a){this._getDownlinkStats(a)},_getDirections:function(){return{localMediaDirections:[l.getReceiverDirection(this.audioEnabled),l.getReceiverDirection(this.videoEnabled||this.screenEnabled)],remoteMediaDirections:[l.getSenderDirection(this.audioEnabled),l.getSenderDirection(this.videoEnabled||this.screenEnabled)]}},_adjustOffer:function(a){this._adjustOfferMediaSectionCommon(a);
!this.videoEnabled&&!this.screenEnabled&&(this.offerSdp.mediaSections=this.offerSdp.mediaSections.slice(0,1));this.offerSdp.flush();return this.offerSdp.toRtcSessionDescription()},_adjustAnswer:function(a,b){var c=new j(b);c.type="answer";c.originator="relay 20518 0 IN IP4 "+a.address;c.globalAttributes["end-of-candidates"]="";c.globalAttributes["ice-lite"]="";c.globalAttributes.fingerprint=a.fingerprint;for(var d=0;d<c.mediaSections.length;d++)this._setStreamerEndpointParamsMediaSection(c.mediaSections[d],
a,d),c.mediaSections[d].overwriteSSRC(c.mediaSections[d].SSRCs[0],a.answerSsrc[d]),c.mediaSections[d].direction=a.remoteMediaDirections[d],c.mediaSections[d].ssrcLabels[a.answerSsrc[d]].cname=a.cname;1<c.mediaSections.length&&(c.mediaSections[1].SSRCs.push(a.answerSsrc[2]),c.mediaSections[1].ssrcLabels[a.answerSsrc[2]]={cname:"du4X8c59zH/810bO"},delete c.mediaSections[1].extmaps[j.HeaderExtensions.ABS_SEND_TIME],c.overwriteMsidLabels());this.recvAudioSsrc=a.answerSsrc[0];this.recvVideoSsrc=a.answerSsrc[1];
this.recvScreenSsrc=a.answerSsrc[2];c.flush();return c.toRtcSessionDescription()},_doRenegotiateMedia:function(){m.d("Renegotiating downlink media");if(2!==this.videoStream.getTracks().length)this._doRenegotiateMediaFull();else if(this._doRenegotiateMediaSimple(),this.onRemoteStreamReady)this.onRemoteStreamReady()},_doRenegotiateMediaFull:function(){var a=this;m.e("Renegotiating media reception. Video enabled? -> "+this.videoEnabled);this._createOffer(f.r(function(){var b=a._getNetworkInfo(a.rawNetworkInfo,
a._getDirections()),c=a._adjustOffer(b),b=a._adjustAnswer(b,c);a._setOfferAndAnswer(c,b)}),{mandatory:{OfferToReceiveAudio:!0,OfferToReceiveVideo:!0}},!1)},_doRenegotiateMediaSimple:function(){var a=new j(this._nativePC.localDescription),b=new j(this._nativePC.remoteDescription);a.mediaSections[0].direction=l.getReceiverDirection(this.audioEnabled);1<a.mediaSections.length&&(a.mediaSections[1].direction=l.getReceiverDirection(this.videoEnabled||this.screenEnabled),f._STATIC_CONFIG.WebRTC.USE_NACK||
a.mediaSections[1].removeNack(),f._STATIC_CONFIG.WebRTC.USE_FEC&&a.mediaSections[1].setFec());a.flush();b.mediaSections[0].direction=l.getSenderDirection(this.audioEnabled);1<a.mediaSections.length&&(b.mediaSections[1].direction=l.getSenderDirection(this.videoEnabled||this.screenEnabled));b.flush();this._setOfferAndAnswer(a.toRtcSessionDescription(),b.toRtcSessionDescription())},onaddstream:function(a){switch(e(a.stream)){case i:this.videoStream=a.stream;this.videoSinkId=o.RenderCtrl.addSink(a.stream);
break;case c:this.screenStream=a.stream;this.screenSinkId=o.RenderCtrl.addSink(a.stream);break;case g:o.RenderCtrl.removeSink(this.videoSinkId,!0),this.videoStream=a.stream,this.videoSinkId=o.RenderCtrl.addSink(a.stream)}if(this.onRemoteStreamReady&&(!this.screenEnabled||this.screenStream))if(!this.videoEnabled||this.videoStream)this.onRemoteStreamReady(),this.onRemoteStreamReady=!1},_translateStats:function(a){for(var c={},d={},a=a.result(),e,f=0;f<a.length;f++){var g=a[f];if(/^Conn/.test(g.id))e=
parseInt(g.stat("bytesReceived"),10);else if(/^ssrc/.test(g.id)){for(var h={},i=g.names(),j=0;j<i.length;j++)h[i[j]]=g.stat(i[j]);h.timestamp=g.timestamp.getTime();parseInt(h.ssrc,10)===parseInt(this.recvAudioSsrc,10)?c=h:parseInt(h.ssrc,10)===parseInt(this.recvVideoSsrc,10)?d=h:(parseInt(h.ssrc,10),parseInt(this.recvScreenSsrc,10))}}d.bytesReceived=e-parseInt(c.bytesReceived,10);this.prevAudioStats=c;this.prevVideoStats=d;e=c;a=this.prevAudioStats;c={totalKbps:0,cumulativePacketLoss:0,fractionLost:0,
rtt:0,timestamp:0,bufferLength:0};e.interarrivalJitter=e.googJitterReceived||0;b(c,e,a);e={totalKbps:0,cumulativePacketLoss:0,fractionLost:0,rtt:0,timestamp:0,cpu:0,totalCpu:0,fps:0,processingTime:0,psnr:0,qdl:0,avOffset:0};b(e,d,this.prevVideoStats);e.fps=d.googFrameRateSent||d.mozFrameRateSent||0;e.frameWidth=d.googFrameWidthSent||d.mozFrameWidthSent||0;e.frameHeight=d.googFrameHeightSent||d.mozFrameHeightSent||0;return{audio:c,video:e}}};i="AUDIO";g="AUDIO_AND_VIDEO";c="VIDEO";d="EMPTY";o.WrtcDownlinkConn=
h})(window);(function(a){function d(b,c){var d={iceServers:[]};b&&b.forEach(function(a){d.iceServers.push(i(a))});var e=new a.RTCPeerConnection(d,{optional:[{DtlsSrtpKeyAgreement:!0}]});m.forEach(function(a){c[a]&&(e[a]=c[a].bind(c))});return e}function g(a){m.forEach(function(b){a[b]=h.Utils.nop()})}function i(a){var b={credential:a.passwd,username:a.uname};b.url=a.type===l.TLS?"turns:":"turn:";b.url+=a.host+":"+a.port;a.type!==l.UDP&&(b.url+="?transport=tcp");return b}function c(a,b){return"0 1 UDP "+o+" "+
a+" "+b+" typ host"}var h=a.ADL,e=h.MediaEngine,b,f,o=2130706431,m=["oniceconnectionstatechange","onaddstream"],j={SSRC_AUDIO_LEVEL:1,TOFFSET:2},l={TCP:"TCP",TLS:"TLS",UDP:"UDP"},k={CREATED:"CREATED",CONNECTING:"CONNECTING",CONNECTED:"CONNECTED",TERMINATED:"TERMINATED"},t={initCommon:function(a,c){f=h.Log;b=e.ManageableSDP;this.state=k.CREATED;this.scopeId=a;this._nativePC=d(c,this);this._renegotiateStreamsQueue=[]},tearDownCommon:function(){null!==this._nativePC&&this._nativePC.close();this.state=
k.TERMINATED;g(this._nativePC);delete this._nativePC;this._nativePC=null},isConnected:function(){return this.state===k.CONNECTED},renegotiateEnabledStreams:function(a,b,c){this.state===k.CONNECTING?(this._renegotiateStreamsQueue.push({audioPublished:a,videoPublished:b,screenPublished:c}),f.d("Queued request to change the streaming configuration")):a===this.audioEnabled&&b===this.videoEnabled&&c===this.screenEnabled?f.d("Got request to change media status with configuration same to current one. Skipping."):
(this.audioEnabled=a,this.videoEnabled=b,this.screenEnabled=c,this._doRenegotiateMedia())},getStats:function(a){var b=this;this._nativePC.getStats(function(c){a.resultAsync(b._translateStats(c))})},_createOffer:function(a,c,d){var e=this;d&&(this.localStream=d,this._nativePC.addStream(this.localStream));this._nativePC.createOffer(function(c){f.d("[BC} = Offer prepared");e.offerSdp=new b(c);a.result(e.offerSdp.getAuthResponseDetails())},function(a){f.d("[BC] = createOffer failed: "+a)},c)},_setStreamerEndpointParamsMediaSection:function(a,
b,c){a.attributes["ice-options"]="trickle";a.attributes.candidate=b.candidates[c];a.port=b.ports[c];a.rtcp.addrInfo="IN IP4 "+b.address;a.rtcp.port=b.ports[c];a.attributes["ice-ufrag"]=b.bundleIceCredentials.ufrag;a.attributes["ice-pwd"]=b.bundleIceCredentials.pwd;delete a.attributes.fingerprint;a.attributes.setup="active"},_connectCommon:function(a,b,c){this.connResponder=a;this.state=k.CONNECTING;this._storeStreamerConfig(b);b=this._getNetworkInfo(b,c);a=this._adjustOffer(b);b=this._adjustAnswer(b,
a);this._setOfferAndAnswer(a,b)},_onConnError:function(a,b){f.d("[BC] = "+a+" failed: "+b)},_storeStreamerConfig:function(a){this.streamerAudioIceCandidates=a.audioIceCandidates;this.streamerVideoIceCandidates=a.videoIceCandidates;this.streamerBundleIceCandidates=a.bundleIceCandidate;this.audioSsrc=a.localAudioSsrc;this.videoSsrc=a.localVideoSsrc0},_setOfferAndAnswer:function(a,b){f.d("[BC} = Applying adjusted offer: "+a.sdp);f.d("[BC} = Applying adjusted answer: "+b.sdp);var c=this,d=function(){f.d("[BC} = Remote SDP set")};
this._nativePC.setLocalDescription(a,function(){c._nativePC.setRemoteDescription(b,d,c._onConnError.bind(c,"setRemoteDescription"))},this._onConnError.bind(c,"setLocalDescription"))},_getNetworkInfo:function(a,b){var d={localMediaDirections:b.localMediaDirections,remoteMediaDirections:b.remoteMediaDirections,isBundledMedia:this.offerSdp.isBundledMedia(),fingerprint:a.fingerprint,bundleIceCredentials:a.bundleIceCredentials};d.isBundledMedia?(d.ports=[this.streamerBundleIceCandidates.port,this.streamerBundleIceCandidates.port],
d.address=this.streamerBundleIceCandidates.address):(d.ports=[this.streamerAudioIceCandidates.port,this.streamerVideoIceCandidates.port],d.address=this.streamerAudioIceCandidates.address);d.candidates=[c(d.address,d.ports[0]),c(d.address,d.ports[1])];d.offerSsrc=[a.localAudioSsrc,a.localVideoSsrc0];d.answerSsrc=[a.remoteAudioSsrc,a.remoteVideoSsrc0,a.remoteScreenSsrc];f.d("Parsed network info: "+JSON.stringify(d));return d},_adjustOfferMediaSectionCommon:function(a){this.offerSdp.mediaSections[0].setCodecByName("ISAC/16000");
this.offerSdp.mediaSections[0].extmaps[b.HeaderExtensions.SSRC_AUDIO_LEVEL]=j.SSRC_AUDIO_LEVEL;1<this.offerSdp.mediaSections.length&&(this.offerSdp.mediaSections[1].setCodecByName("VP8/90000"),this.offerSdp.mediaSections[1].maxBandwidth=this.maxUplinkRate,this.offerSdp.mediaSections[1].extmaps[b.HeaderExtensions.TOFFSET]=j.TOFFSET,h._STATIC_CONFIG.WebRTC.USE_NACK||this.offerSdp.mediaSections[1].removeNack(),h._STATIC_CONFIG.WebRTC.USE_FEC&&(f.d("enabling FEC"),this.offerSdp.mediaSections[1].setFec()));
for(var c=h.Utils.randomString(16),d=0;d<this.offerSdp.mediaSections.length;d++)1<this.offerSdp.mediaSections[d].SSRCs.length&&(this.offerSdp.mediaSections[d].SSRCs=[this.offerSdp.mediaSections[d].SSRCs[0]]),this._prepareOfferMediaSection(this.offerSdp.mediaSections[d],a.offerSsrc[d],a.localMediaDirections[d],c);1<this.offerSdp.mediaSections.length&&delete this.offerSdp.mediaSections[1].extmaps[b.HeaderExtensions.ABS_SEND_TIME];return this.offerSdp},_prepareOfferMediaSection:function(a,c,d,e){1===
a.SSRCs.length?a.overwriteSSRC(a.SSRCs[0],c):(a.SSRCs.push(c),a.ssrcLabels[c]={});void 0===a.ssrcLabels.cname&&(a.ssrcLabels[c].cname=e);a.attributes["ice-options"]="trickle";a.crypto=void 0;a.attributes.setup="actpass";a.direction=d;delete a.extmaps[b.HeaderExtensions.ABS_SEND_TIME]},oniceconnectionstatechange:function(a){f.d("[BC} = New ICE state: "+a.target.iceConnectionState);if("connected"===a.target.iceConnectionState||"completed"===a.target.iceConnectionState){this.state=k.CONNECTED;var b=
this;this._renegotiateStreamsQueue.forEach(function(a){b.renegotiateEnabledStreams(a.audioPublished,a.videoPublished,a.screenPublished)});this.connResponder.resultAsync()}}};e.WrtcConnHelper={applyBaseWrtConnMixin:function(a){for(var b in t)t.hasOwnProperty(b)&&(a[b]=t[b])},getSenderDirection:function(a){return a?"sendonly":"inactive"},getReceiverDirection:function(a){return a?"recvonly":"inactive"},genIceCandidate:c};e.RtpExtensionIds=j;e.TurnTransportType=l;e.WrtcConnState=k})(window);(function(){ADL.RELEASE_LEVEL="stable";ADL.VERSION="3.6.6";ADL._PLUGIN_UPDATE_ROOT={win:"https://d36pfzlm4aixmv.cloudfront.net/plugin-release/Release/3.0.6.3/",mac:"https://d36pfzlm4aixmv.cloudfront.net/releases/Release/3.0.6.3/",mac_106:"https://d36pfzlm4aixmv.cloudfront.net/releases_OSX_105/Release/3.0.1.26/"};ADL._PLUGIN_INSTALL_ROOT={win:"https://d36pfzlm4aixmv.cloudfront.net/plugin-release/Release/3.0.6.3/",mac:"https://d36pfzlm4aixmv.cloudfront.net/releases/Release/3.0.6.3/",mac_106:"https://d36pfzlm4aixmv.cloudfront.net/releases_OSX_105/Release/3.0.1.26/"};
ADL._BUG_REPORTING_ENDPOINT="https://cnc2.addlive.com/reliability/";ADL._LOGS_REPORTING_ENDPOINT="//cnc3.addlive.com/user_logs.store";ADL._STREAMER_ENDPOINT_RESOLVER="https://cnc.addlive.com/resolve_streamer.do|https://cnc2.addlive.com/resolve_streamer.do|https://cnc3.addlive.com/resolve_streamer.do";ADL._TRACKING_ENDPOINT="//cnc2.addlive.com/tracker.gif"})();